Package: CHETAH
Title: Fast and accurate scRNA-seq cell type identification
Type: Package
Version: 1.28.0
Date: 2025-10-14
Authors@R: c(person("Jurrian", "de Kanter", email = "jurriandekanter@gmail.com",  role = c("aut", "cre")),
             person("Philip", "Lijnzaad", email = "p.lijnzaad@prinsesmaximacentrum.nl", role = c("aut")))
Description: CHETAH (CHaracterization of cEll Types Aided by Hierarchical classification) is an accurate, selective and fast scRNA-seq classifier.
	  Classification is guided by a reference dataset,
    preferentially also a scRNA-seq dataset. By hierarchical clustering of the reference data, CHETAH creates
	  a classification tree that enables a step-wise, top-to-bottom classification. Using a novel stopping rule,
	  CHETAH classifies the input cells to the cell types of the references and to "intermediate types": more general
	  classifications that ended in an intermediate node of the tree.
Imports: shiny, plotly, pheatmap, bioDist, dendextend, cowplot,
        corrplot, grDevices, stats, graphics, reshape2, S4Vectors,
        SummarizedExperiment
Depends: R (>= 4.2), ggplot2, SingleCellExperiment
License: file LICENSE
Encoding: UTF-8
biocViews: Classification, RNASeq, SingleCell, Clustering,
        GeneExpression, ImmunoOncology
RoxygenNote: 7.2.0
Suggests: knitr, rmarkdown, Matrix, testthat, vdiffr
VignetteBuilder: knitr
LazyData: false
BugReports: https://github.com/jdekanter/CHETAH
URL: https://github.com/jdekanter/CHETAH
git_url: https://git.bioconductor.org/packages/CHETAH
git_branch: RELEASE_3_23
git_last_commit: e5eb1b6
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 21:12:07 UTC; biocbuild
Author: Jurrian de Kanter [aut, cre],
  Philip Lijnzaad [aut]
Maintainer: Jurrian de Kanter <jurriandekanter@gmail.com>

# CHETAH: a selective, hierarchical cell type identification method for single-cell RNA sequencing
__CHETAH is an R package for cell type identification of single-cell RNA-sequencing (scRNA-seq) data.__
Cell types are assigned by correlating the input data to a reference in a hierarchical manner. CHETAH is built to work with scRNA-seq references, but will also work (with limited capabilities) with RNA-seq or micro-array reference datasets.


The article describing CHETAH can be found at: [Nucleic Acids Research](https://academic.oup.com/nar/advance-article/doi/10.1093/nar/gkz543/5521789?searchresult=1).  

> CHETAH is now part of [Bioconductor](https://www.bioconductor.org/packages/release/bioc/html/CHETAH.html).  

CHETAH can be installed by running:
```{r echo=TRUE, eval=FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("CHETAH")
```

To get to know the basics of the CHETAH pacakge, please look at the vignette;
```{r echo=TRUE, eval=FALSE}
vignette("CHETAH_introduction")
```

At a glance: to run chetah on an input count matrix `input_counts` with t-SNE coordinates in `input_tsne`, and a reference count matrix `ref_counts` with celltypes vector `ref_ct`, run:  

```{r glance, echo=TRUE, eval=FALSE}
## Make SingleCellExperiments
reference <- SingleCellExperiment(assays = list(counts = ref_counts),
                                     colData = DataFrame(celltypes = ref_ct))

input <- SingleCellExperiment(assays = list(counts = input_counts),
                              reducedDims = SimpleList(TSNE = input_tsne))

## Run CHETAH
input <- CHETAHclassifier(input = input, ref_cells = reference)

## Plot the classification
PlotCHETAH(input)

## Extract celltypes:
celltypes <- input$celltype_CHETAH
```

server <- function(input, output, session) {
  ## ----------------------------------- Startup notification ------------------
  observe({
    showNotification("Welcome to the CHETAH shiny application.
Here, you can interact with your data and the CHETAH output.
Most plots have a help-message that can be viewed by hovering over the title of the plot.
Download buttons are present below each plot.
(These functions work better in a web-browser: click 'Open in Browser' on top of the Rstudio-window.)
Each t-SNE plot is interactive, so you can zoom in and out. Other plots will adapt
to only show information of the cells in the currently selected t-SNE window.
See the 'Info' tab for info about the method.", duration = 60)
  })

  ## Make short links (variables) to the chetah data [links without adjustment don't take up space]
  coor <- SingleCellExperiment::reducedDim(CHETAH:::ch_env$chetah, CHETAH:::ch_env$redD)
  counts <- SummarizedExperiment::assay(CHETAH:::ch_env$chetah, CHETAH:::ch_env$input_c)
  conf_scores <- CHETAH:::ch_env$chetah@int_colData$CHETAH$conf_scores
  prof_scores <- CHETAH:::ch_env$chetah@int_colData$CHETAH$prof_scores
  meta_data <- CHETAH:::ch_env$chetah@int_metadata$CHETAH
  chetah <- CHETAH:::ch_env$chetah
  redD <- CHETAH:::ch_env$redD
  input_c <- CHETAH:::ch_env$input_c

  ## ----------------------------------- Select colors ------------------
  ## Confidence t-SNE color gradient
  grad_col <- c(gplots::colorpanel(n = 50, low = '#2f2bad', mid = '#68cded', high = '#f4f4f4'),
                gplots::colorpanel(n = 50, low = '#f4f4f4', mid = "#ff9f19", high = '#d60000'))
  ## Cell type colors
  Clrs <- reactive({
    req(chetah)
    colors <- c ('blue', 'gold', 'cyan3', 'navy',
                 'forestgreen', 'orange', 'darkolivegreen3',
                 'brown', 'green', 'purple','deepskyblue', 'cyan',
                 'orangered3', 'coral', 'yellow3', "black",
                 'yellow1', 'darkorchid1', 'darksalmon', 'darkseagreen1',
                 'darkslategrey', 'deeppink4', 'green2', 'lemonchiffon1',
                 'lightcyan', 'midnightblue', 'maroon1', 'orange3', 'palegreen',
                 'palevioletred1', 'peru', 'seagreen1', 'red3', 'snow2',
                 'steelblue1', 'turquoise')
    nnodes <- names(meta_data$nodetypes[[1]])
    nodes <- c("Unassigned", paste0("Node", seq_len(length(meta_data$nodetypes) - 1)))
    if(input$colornodes) {
      n <- nodes
      nodes <- nnodes
      nnodes <- n
      rm(n)
    }
    if (length(nodes) < 24)   {
      gray <- paste0('gray', rev(seq(2, 92, 4)))
    } else if (length(nodes) < 24) {
      gray <- paste0('gray', rev(seq(2, 92, 2)))
    } else {
      gray <- rep('gray70', length(nodes))
    }
    if (length(nnodes) > 36) colors <- grDevices::rainbow(length(nnodes) + 1)
    names(colors) <- nnodes
    names(gray) <- nodes
    cols <- c(gray, colors)
    cols <- cols[!is.na(names(cols))]
    return(cols)
  })
  ## Reactive event definition
  ReDefineData <- function(event, data, coor) {
    data <- data.frame(data)
    if (!is.null(event)) {
      if(names(event)[1] == "xaxis.range[0]") {
        select <- rownames(coor)[coor[,1] > event[["xaxis.range[0]"]] &
                                   coor[,1] < event[["xaxis.range[1]"]] &
                                   coor[,2] > event[["yaxis.range[0]"]] &
                                   coor[,2] < event[["yaxis.range[1]"]]]
        data <- data[rownames(data) %in% select, , drop = FALSE]
      }
    }
    return(data)
  }
  ## ----------------------------------- Render UI ---------------------------
  ## Extract classification
  classification <- reactive({
    req(input$conf_thresh, chetah)
    Classify(chetah, input$conf_thresh, return_clas = TRUE)
  })
  ## Select a node
  output$nodebutton <- renderUI ({
    req(chetah)
    splitmax <- length(conf_scores)
    choices <- seq_len(splitmax)
    names(choices) <- c(0, seq_len(splitmax - 1))
    selectInput(inputId = "whichnode",
                label = p("Choose a Node", class = 'opt'),
                choices = choices)
  })
  ## Select a type
  output$typebutton <- renderUI ({
    req(input$whichnode)
    choices <- names(meta_data$nodetypes[[as.numeric(input$whichnode)]])
    selectInput(inputId = "whichtype",
                label = p("Choose a Type", class = 'opt'),
                choices = choices)
  })
  ## Select a type for differential expression
  output$typebutton_DE <- renderUI ({
    req(input$whichnode)
    choices <- names(meta_data$nodetypes[[1]])
    selectInput(inputId = "whichtype_DE",
                label = p("Choose a Type", class = 'opt'),
                choices = choices)
  })
  ## Check whether the current type is in the current branch, otherwise stop plotting
  typecorrect <- reactive({
    req(input$whichtype, input$whichnode)
    input$whichtype %in% names(meta_data$nodetypes[[as.numeric(input$whichnode)]])
  })
  ## Select a gene for Tab 5
  output$geneselection <- renderUI ({
    req(counts)
    choices <- rownames(counts)
    selectInput(inputId = "whichgene",
                label = p("Choose a Gene", class = 'opt'),
                choices = choices)
  })
  ## ----------------------------------- Tab 1 ---------------------------
  ## Classification t-SNE
  classTsne <- reactive({
    req(classification(), coor)
    toplot <- classification()
    toplot[toplot == "Unassigned"] <- "Unassigned (Node0)"
    u_toplot <- unique(toplot)
    toplot <- data.frame(factor(toplot, levels = c(u_toplot[grepl("Unassigned", u_toplot)],
                                        sort(u_toplot[grepl("Node", u_toplot) & !grepl("\\(Node0)", u_toplot)]),
                                        sort(u_toplot[!grepl("Node|Unassigned", u_toplot)]))))
    colnames(toplot) <- 'Cell type'
    clrs <- Clrs()
    names(clrs)[names(clrs) == "Unassigned"] <- "Unassigned (Node0)"
    PlotTSNE(toplot = toplot, input = chetah, redD = redD, col = clrs,
             pt.size = input$ptsize, return = TRUE, shiny = 'Cell type: ') +
      guides(color=guide_legend(title="Cell types")) +
      guides(color=guide_legend(override.aes = list(size=6)), legend_label = 'Cell type')
  })
  output$classTsne <- plotly::renderPlotly({
    classTsne_plot <- plotly::ggplotly(classTsne(), tooltip = 'text')
    plotly::config(classTsne_plot, modeBarButtonsToRemove = c('toggleSpikelines','lasso2d', 'select2d', 'hoverCompareCartesian'), collaborate = FALSE)
  })
  output$dwn_clTsne <- downloadHandler(
    filename = function() { paste0('CHETAH_classification_', input$conf_thresh, '.png') },
    content = function(file) {
      ggsave(file, plot = classTsne(), device = "png", width = 20, height = 12, dpi = 400)
    }
  )
  ## Classification Tree output
  classTree <- reactive({
    req(Clrs())
    if (input$colornodes) interm <- TRUE else interm <- FALSE
    if(interm) PlotTree(input = chetah, col_nodes = Clrs(), no_bgc = TRUE) else {
      PlotTree(input = chetah, col = Clrs()) + ggtitle('')
    }
  })
  output$classTree <- renderPlot({ classTree() })
  output$dwn_clTree <- downloadHandler(
    filename = function() { 'CHETAH_tree.png' },
    content = function(file) {
      ggsave(file, plot = classTree(), device = "png", width = 20, height = 12, dpi = 400)
    }
  )
  ## Calculate cell type percentage
  typestable <- reactive({
    req(classification())
    types <- unique(classification())
    types <- c(sort(types[!grepl('Node|Unassigned', types)]), types[grepl('Unassigned', types)] , sort(types[grepl('Node', types)]))
    perc <- vector()
    for (i in types) perc <- c(perc, round(sum(classification() == i)/length(classification()), 4)*100)
    data <- data.frame(types, perc, stringsAsFactors = TRUE)
    data$types <- factor(types, levels = types)
    ggplot(data, aes_string(x = 'types', y = 'perc', label = 'perc')) +
      geom_bar(stat = 'identity', aes_string(fill = 'types')) +
      theme_classic() +
      scale_fill_manual(values =Clrs()) +
      geom_text(vjust = -0.5, fontface = 'bold')
  })
  output$typestable <- renderPlot({ typestable() })
  output$dwn_ttable <- downloadHandler(
    filename = function() { 'CHETAH_percentages.png' },
    content = function(file) {
      ggsave(file, plot = typestable(), device = "png", width = 20, height = 12, dpi = 400)
    }
  )
  ## ----------------------------------- Tab 2 ---------------------------
  ## Plot colored classification tree
  confTree <- reactive({
    req(Clrs(), input$whichnode)
    ## All black labels
    nodecl <- rep('#000000', length(Clrs()))
    names(nodecl) <- names(Clrs())
    ## Color the branches of the current node
    which <- as.numeric(input$whichnode)
    nodetp <- meta_data$nodetypes[[which]]
    lowerns <- (which+1):length(conf_scores)
    nodes <- unlist(lapply(meta_data$nodetypes[lowerns], function (x) {
      if (all(names(x) %in% names(meta_data$nodetypes[[which]]))) {
        nodetp[names(x)][1]
      } else 3
    }))
    names(nodes) <- paste0('Node', lowerns - 1) ## The names are shifted 1 place
    nodes <- nodes[nodes !=  3]
    nodecl[c(names(nodetp)[nodetp == 1], names(nodes)[nodes == 1])] <- '#ff0a0a'
    nodecl[c(names(nodetp)[nodetp == 2], names(nodes)[nodes == 2])] <- '#00a1ff'
    ## Plot tree
    PlotTree(chetah, col = nodecl, col_nodes = nodecl, no_bgc = TRUE) + ggtitle('')
  })
  output$confTree <- renderPlot({ confTree() })
  output$dwn_confTree <- downloadHandler(
    filename = function() { paste0('CHETAHtree_node', input$whichnode, '.png') },
    content = function(file) {
      ggsave(file, plot = confTree(), device = "png", width = 20, height = 12, dpi = 400)
    }
  )
  ## Select the max confidence of a cell in the current node
  MaxConf <- reactive ({
    req(input$whichnode)
    which <- as.numeric(input$whichnode)
    data <- conf_scores[[which]]
    maxs <- apply(as.matrix(data), 1, max)
    wmax <- apply(as.matrix(data), 1, which.max)
    wmax <- meta_data$nodetypes[[which]][colnames(data)][wmax]
    maxs[wmax == 2] <- -maxs[wmax == 2]
    return(maxs)
  })

  ## Select current types incl nodes
  SlctNodes <- reactive ({
    req(input$whichnode)
    which <- as.numeric(input$whichnode)
    nodes <- unlist(lapply(meta_data$nodetypes[(which):length(conf_scores)], function (x) {
      all(names(x) %in% names(meta_data$nodetypes[[which]]))
    }))
    nodes <- paste0('Node', ((which - 1):(length(conf_scores) - 1))[nodes])
    nodes[grepl("Node0", nodes)] <- "Unassigned"
    nodes <- c(nodes, names(meta_data$nodetypes[[which]]))
    return(nodes)
  })

  ## Select the input cell still in the current branch
  SlctCells <- reactive ({
    req(SlctNodes, classification())
    cellnms <- names(classification())[classification() %in% SlctNodes()]
    return(cellnms)
  })

  ## Confidence t-SNE
  confTsne <- reactive({
    req(SlctCells(), MaxConf(), input$whichnode)
    data <- data.frame(MaxConf()[SlctCells()], classification()[SlctCells()])
    colnames(data) <- c('Confidence', 'cell type')
    coor_prof <- coor[SlctCells(), ]
    coor_prof <- coor_prof[rownames(data), ]
    pl <- PlotTSNE(toplot = data, input = chetah, redD = redD,
                   col = grad_col, limits = c(-2,2),
                   pt.size = input$ptsize, return = TRUE, shiny = 'confidence score: ',
                   x_limits = c(min(coor[,1]), max(coor[,1])),
                   y_limits = c(min(coor[,2]), max(coor[,2])),
                   legend_label = 'Confidence')
    pl + labs(color = 'Confidence')
  })
  output$confTsne <- plotly::renderPlotly({
    confTsne_plot <- plotly::ggplotly(confTsne(), tooltip = c('text'), source = 'conf')
    plotly::config(confTsne_plot, modeBarButtonsToRemove = c('toggleSpikelines','lasso2d', 'select2d', 'hoverCompareCartesian'), collaborate = FALSE)
  })
  output$dwn_confTsne <- downloadHandler(
    filename = function() { paste0('CHETAH_confidence_node', input$whichnode, '.png') },
    content = function(file) {
      ggsave(filename = file, plot = confTsne(), device = "png", width = 20, height = 12, dpi = 400)
    }
  )

  ## Observe plotly_event, but update to null, when new node is chosen: this doesn't happen automatically
  zoom <- reactive ({ plotly::event_data("plotly_relayout", source = 'conf') })
  rv <- reactiveValues(conf = NULL)
  observeEvent(zoom(), {
    rv$conf <- zoom()
  })
  observeEvent(input$whichnode, {
    rv$conf <- NULL
  })

  ## Confidence heatmap
  confHM <- reactive({
    req(SlctCells(), MaxConf(), input$whichnode, rv)
    ## select the data and sort
    which <- as.numeric(input$whichnode)
    data <- prof_scores[[which]]
    branchtypes <- sort(meta_data$nodetypes[[which]])
    data <- data[ ,names(branchtypes)]
    data <- data[names(sort(MaxConf())), ]
    data <- data[rownames(data) %in% SlctCells(), ]
    data <- ReDefineData(event = rv$conf, data = data, coor = coor)
    classif <- data.frame('celltypes' = classification()[rownames(data)])
    if (nrow(data) > 0) {
      if (input$sortByType)  data <- data[rownames(classif)[order(classif)], ]
      ann_col <- list('celltypes' = Clrs()[SlctNodes()])
      ## Rescale gradient colors
      rng <- (range(data) + 1)*50
      grad_clrs <- grad_col[rng[1]:rng[2]]

      pheatmap::pheatmap(t(data),
                         color = grad_clrs,
                         border_color = NA,
                         cluster_cols = FALSE,
                         cluster_rows = FALSE,
                         show_colnames = FALSE,
                         scale = "none",
                         annotation_col = classif,
                         annotation_colors = ann_col,
                         height = input$matrixheight)
    } else {
      NULL
    }
  })

  output$confHM <- renderPlot({
    if ('RStudioGD' %in% names(dev.list())) dev.off(which = which(names(dev.list()) == 'RStudioGD') + 1)
    print(confHM())
  })

  output$dwn_confHM <- downloadHandler(
    filename = function() { paste0('CHETAH_prof_score_heatmap_node', input$whichnode, '.png') },
    content = function(file) {
      png(file, width = 20, height = 12, res = 400, units = 'in')
      print(confHM())
      dev.off()
    }
  )
  ## ----------------------------------- Tab 3 ---------------------------
  ## Zoom of tSNE must be retained when new data is plotted: this doesn't happen automatically
  zoom2 <- reactive ({ plotly::event_data("plotly_relayout", source = 'prof') })
  rv2 <- reactiveValues(prof = NULL)
  observeEvent(input$whichnode, {
    rv2$prof <- zoom2()
  })
  observeEvent(input$whichtype, {
    rv2$prof <- zoom2()
  })
  observeEvent(zoom2(), {
    rv2$prof <- NULL
  })
  ## Profiel score t-SNE
  profTsne <- reactive({
    req(typecorrect(), chetah, rv2)
    toplot <- data.frame(prof_scores[[as.numeric(input$whichnode)]][ ,input$whichtype, drop = FALSE],
                         classification())
    colnames(toplot) <- c('Profile score', 'cell type')
    if (!is.null(rv2$prof)) toplot <- ReDefineData(event = zoom2(), data = toplot, coor = coor)
    coor <- coor[rownames(toplot), ]
    pl <- PlotTSNE(toplot, input = chetah, redD = redD,
                   col = grad_col,
                   limits = c(-1,1),
                   pt.size = input$ptsize, return = TRUE, shiny = 'Profile score: ',
                   legend_label = 'Profile score') +
      labs(color = 'Profile score')
    pl
  })
  output$profTsne <- plotly::renderPlotly({
    profTsne_plot <- plotly::ggplotly(profTsne(), tooltip = c('text'), source = 'prof')
    plotly::config(profTsne_plot, modeBarButtonsToRemove = c('toggleSpikelines','lasso2d', 'select2d', 'hoverCompareCartesian'), collaborate = FALSE)
  })
  output$dwn_profTsne <- downloadHandler(
    filename = function() { paste0('CHETAH_prof_scores_node', input$whichnode, 'type_', input$whichtype, '.png') },
    content = function(file) {
      png(file, width = 20, height = 12, res = 400, units = 'in')
      print(profTsne())
      dev.off()
    }
  )
  ## Profile score Boxplot
  profBox <- reactive({
    req(typecorrect(), chetah)
    toplot <- as.data.frame(prof_scores[[as.numeric(input$whichnode)]][ ,input$whichtype, drop = FALSE])
    clas   <- as.data.frame(classification())
    event  <- plotly::event_data("plotly_relayout", source = 'prof')
    toplot <- ReDefineData(event = event, data = toplot, coor = coor)
    clas   <- ReDefineData(event = event, data = clas, coor = coor)
    CHETAH:::PlotBox(class = clas,
            toplot = toplot,
            col = Clrs())
  })

  output$profBox <- renderPlot({ profBox() })
  output$dwn_profBox <- downloadHandler(
    filename = function() { paste0('CHETAHboxpl_prof_scores_node', input$whichnode, 'type_', input$whichtype, '.png') },
    content = function(file) {
      png(file, width = 20, height = 12, res = 400, units = 'in')
      print(profBox())
      dev.off()
    }
  )

  ## Plot colored classification tree
  celltTree <- reactive({
    req(typecorrect())
    function(){
      ## All black labels
      nodecl <- rep('#000000', length(Clrs()))
      names(nodecl) <- names(Clrs())
      ## Color the current type in the current node
      which <- as.numeric(input$whichnode)
      lowerns <- (which+1):length(meta_data$nodetypes)
      nodetp <- meta_data$nodetypes[[which]]
      nodes <- unlist(lapply(meta_data$nodetypes[lowerns], function (x) {
        if (all(names(x) %in% names(meta_data$nodetypes[[which]]))) {
          nodetp[names(x)][1]
        } else 3
      }))
      names(nodes) <- paste0('Node', lowerns - 1)
      nodes <- nodes[nodes !=  3]
      if (input$whichtype %in% names(nodetp)[nodetp == 1]) {
        nodecl[c(names(nodetp)[nodetp == 2], names(nodes)[nodes == 2])] <- '#ff0a0a'
        nodecl[input$whichtype] <- '#00a1ff'
      } else {
        nodecl[c(names(nodetp)[nodetp == 1], names(nodes)[nodes == 1])] <- '#00a1ff'
        nodecl[input$whichtype] <- '#ff0a0a'
      }
      ## Plot tree
      PlotTree(chetah, col = nodecl, col_nodes = nodecl, no_bgc = TRUE) + ggtitle('')
    }
  })
  output$profTree <- renderPlot({ celltTree()() })
  ## ----------------------------------- Tab4  ---------------------------
  ## Select cells
  HMcells <- reactive({
    req(typecorrect(), classification(), SlctNodes())
    which <- as.numeric(input$whichnode)
    ## Select cells
    branchtypes <- names(sort(meta_data$nodetypes[[which]]))
    if (input$inclnodes) {
      branchtypes <- c(branchtypes, SlctNodes()[grepl("Node|Unassigned", SlctNodes())])
    }
    cells <- classification()[classification() %in% branchtypes]
    cells <- cells[order(match(cells, branchtypes))]
    validate(
      need(cells > 0, "
           No cells to display in this Node. Lowering the 'Confidence Threshold' might work.
           Please check the 'Classification' tab to see the classification with the current 'Confidence Threshold'")
      )
    return(cells)
  })

  ## Select genes
  HMgenes <- reactive({
    req(HMcells())
    which <- as.numeric(input$whichnode)
    ## Select Genes
    if (input$largediff) {
      finaltypes <- sort(meta_data$nodetypes[[which]])
      lh_genes <- meta_data$genes[[which]][[input$whichtype]]
      data <- as.matrix(counts[names(lh_genes), names(HMcells())])
      r_branch <- apply(as.matrix(data[ ,names(HMcells())[HMcells() %in% names(finaltypes)[finaltypes == 1]]]), 1, mean)
      l_branch <- apply(as.matrix(data[ ,names(HMcells())[HMcells() %in% names(finaltypes)[finaltypes == 2]]]), 1, mean)
      lh_genes <- lh_genes[names(sort(abs(r_branch - l_branch), decreasing = TRUE))[seq_len(input$n_genes)]]
      lh_genes <- sort(lh_genes)
      ## If no cells in one of the two branches: Don't sort
      if (length(lh_genes) == 0) lh_genes <- sort(meta_data$genes[[which]][[input$whichtype]][seq_len(input$n_genes)])
    } else {
      lh_genes <- sort(meta_data$genes[[which]][[input$whichtype]][seq_len(input$n_genes)])
    }
    lh_genes[lh_genes == 0] <- 'lowly'
    lh_genes[lh_genes == 1] <- 'highly'
    return(lh_genes)
  })

  ## Gene heatmap
  exprHM <- reactive({
    req(HMgenes())
    which <- as.numeric(input$whichnode)
    ## Select cells
    branchtypes <- names(sort(meta_data$nodetypes[[which]]))
    if (input$inclnodes) {
      branchtypes <- c(branchtypes, SlctNodes()[grepl("Node|Unassigned", SlctNodes())])
    }
    genes <- names(HMgenes())
    data <- as.matrix(counts[genes, names(HMcells())])

    hl_clrs <- c('black', 'gray80')
    names(hl_clrs) <- c('lowly', 'highly')
    annotation_col <- data.frame('celltypes' = HMcells())
    annotation_row <- data.frame('Expressed_in_this_type' = HMgenes())
    ann_col <- list('celltypes' = Clrs()[branchtypes],
                    'Expressed_in_this_type' = hl_clrs)
    if (input$scaling) scale <- 'row' else scale <- 'none'
    ## Plot
    pheatmap::pheatmap(data,
                       color = grad_col,
                       border_color = NA,
                       cluster_cols = FALSE,
                       cluster_rows = FALSE,
                       show_colnames = FALSE,
                       scale = scale,
                       annotation_col = annotation_col,
                       annotation_row = annotation_row,
                       annotation_colors = ann_col,
                       fontsize_row = input$lettersize,
                       annotation_names_row = FALSE)
  })
  output$exprHM <- renderPlot({
    if ('RStudioGD' %in% names(dev.list())) dev.off(which = which(names(dev.list()) == 'RStudioGD') + 1)
    exprHM()
  })

  output$dwn_exprHM <- downloadHandler(
    filename = function() { paste0('CHETAH_HM_node', input$whichnode, '_', input$whichtype, '.png') },
    content = function(file) {
      png(file, width = 20, height = 12, res = 400, units = 'in')
      print(exprHM())
      dev.off()
    }
  )
  ## Download the genes!
  output$dwn_genes <- downloadHandler(
    filename = function() { paste0('CHETAHgenes_node', input$whichnode, '_', input$whichtype, '.txt') },
    content = function(con) {
      write.table(matrix(names(HMgenes()), ncol = 1), file = con, sep = '\t', quote = FALSE, row.names = FALSE, col.names = FALSE)
    }
  )
  ## Plot classification tree
  output$genesTree <- renderPlot({ celltTree()() })
  ## ----------------------------------- Tab5  ---------------------------
  geneExpr <- reactive({
    req(input$whichgene, classification())
    genes <- counts[input$whichgene, ]
    #if(!is.null(log)) genes <- log2(genes + 1)
    genes <- cbind.data.frame(genes, as.data.frame(classification()))
    #if(!is.null(sub)) genes <- genes[genes$type %in% sub, ]
    colnames(genes) <- c('gene', 'type')
    suppressMessages(genes <- reshape2::melt(genes))

    ggplot(genes, aes(x=type, y = value)) +
      geom_jitter(aes(color = type), size = 2) +
      geom_boxplot(aes(color = type), fill = rgb(1,1,1,0.5), outlier.colour = "NA")  +
      theme_classic() +
      theme(axis.text.x = element_text(angle = 60, hjust = 1, size = 10),
            axis.title.x = element_blank()) +
      guides(color=FALSE) +
      scale_color_manual(values = Clrs())
  })
  output$geneExpr <- renderPlot({ geneExpr() })
  output$dwn_geneExpr <- downloadHandler(
    filename = function() { paste0('CHETAH_gene_exp_', input$whichgene, '.png') },
    content = function(file) {
      png(file, width = 20, height = 12, res = 400, units = 'in')
      print(geneExpr())
      dev.off()
    }
  )
}

# Define UI ----
ui <- fluidPage(
  tags$head(

    ## CSS Style
    tags$style(HTML("
h1 {
  font-family: 'Raleway Black', 'Arial Black', sans-serif;
  color: #ffffff;
}
.options {
  background: #000000;
  min-height: 100%;
}
.opt {
  font-family: 'Raleway ExtraBold', 'Arial Black', sans-serif;
  font-weight: 'bold';
  color: #fcb22a;
}
.value {
  font-family: 'Raleway', 'Arial', sans-serif;
}
h3 {
  font-family: 'Raleway ExtraBold', 'Arial Black', sans-serif;
}
.tabbable > .nav > li > a                  {background-color: #fef2b9;  color:black; font-family: 'Raleway ExtraBold', 'Arial Black', sans-serif;}
.tabbable > .nav > li[class=active]    > a {background-color: #fcb22a;  color:black; font-family: 'Raleway ExtraBold', 'Arial Black', sans-serif;}
                    "))
  ),
  tags$head(tags$style(
    "body { word-wrap: break-word; }"
  )),
  fluidRow(
      img(src="Shiny_bar.png", align = "left", height = "80vh", width = "820vh")
  ),
  #
  #
  fluidRow(
    ## OPTION PANEL 1
    column(2,
           left = '0px',
           fluidRow(style = "background:#000000;",
                      h1("OPTIONS"),
                      ## Color the intermediate types?
                      checkboxInput(inputId = "colornodes",
                                    label = p('Color the intermediate types', class = 'opt'),
                                    value = FALSE),
                      ## Conf threshhold for which cells to classify
                      numericInput("conf_thresh", label = p("Confidence threshold", class = 'opt'),
                                   value = 0.1, step = 0.01),

                      conditionalPanel(
                        condition = "input.MP != 'Genes used by CHETAH' && input.MP != 'Expression per gene'",
                        ## t-SNE point size
                        numericInput("ptsize", label = p("Point Size", class = 'opt'),
                                     value = 1.5, step = 0.5)
                      ),
                      conditionalPanel(
                        condition = "input.MP != 'Classification' && input.MP != 'Expression per gene'",
                        ## Which node to display 2
                        uiOutput(outputId = "nodebutton")
                      ),
                      conditionalPanel(
                        condition = "input.MP == 'Profile scores' || input.MP == 'Genes used by CHETAH'",
                        ## Which type to display 3
                        uiOutput(outputId = "typebutton")
                      ),
                      conditionalPanel(
                        condition = "input.MP == 'Genes used by CHETAH'",
                        ## Scale the matrix 3
                        checkboxInput(inputId = "scaling",
                                      label = p('Scale Matrix', class = 'opt'),
                                      value = FALSE),
                        ## Number of genes 3
                        numericInput(inputId = "n_genes",
                                     label = p('# of genes', class = 'opt'),
                                     value = 60, step = 1, min = 2, max = 200),
                        ## Height of the matrix 3
                        numericInput(inputId = "lettersize",
                                     label = p('Matrix label size', class = 'opt'),
                                     value = 10, step = 0.5, min = 1, max = 20)
                      ),
                      conditionalPanel(
                        condition = "input.MP == 'Genes used by CHETAH'",
                        ## Height of the matrix 3
                        checkboxInput(inputId = "largediff",
                                      label = p('Genes with max. difference in the INPUT', class = 'opt'),
                                      value = TRUE),
                        checkboxInput(inputId = "inclnodes",
                                      label = p('Add intermediate types', class = 'opt'),
                                      value = FALSE)
                      ),
                      conditionalPanel(
                        condition = "input.MP == 'Expression per gene'",
                        ## Height of the matrix 3
                        uiOutput(outputId = 'geneselection')
                      )
           )
    ),
    ## MAIN PANEL
    column(10,
           fluidRow(
             tabsetPanel(id = "MP",
                         ### Tab 1
                         tabPanel("Classification",
                                  fluidRow(
                                    column(12,
                                           ## Classification t-SNE
                                           tags$div(title =
"The cells on the (t-SNE) coordinates that you provided.
Each cell is colored according to the CHETAH cell type.
As in any plot, the strictness of the classification
can be changed using 'Confidence Threshold' on the left panel.
Also, inferred intermediate types (nodes in the tree below)
can be colored with 'Color the intermediate types'.

Please note that cells labeled: 'Unknown' are cells for which
classification stopped in Node0

If more cell types are present than could be shown,
a small scroll bar is present on the right side of the plot",
                                              h3('CHETAH classification')
                                           ),
                                           plotly::plotlyOutput(outputId = 'classTsne', height = 600),
                                           downloadButton('dwn_clTsne', 'Download Plot')
                                    )
                                  ),
                                  fluidRow(
                                    column(12,
                                           ## Classification percentages
                                           tags$div(title =
"The percentages of cell types in you sample,
according to the current 'Confidence Threshold'",
                                               h3("Cell type percentages")
                                           ),
                                           plotOutput('typestable'),
                                           downloadButton('dwn_ttable', 'Download Plot')
                                    )
                                  ),
                                  fluidRow(
                                    column(12,
                                           ## Classification tree
                                           tags$div(title =
"The classification tree that CHETAH constructed
by hierarchically clustering the reference data.
The (leaf) nodes are colored with the same colors
as used in the plots above.",
                                              h3("Classification tree")
                                           ),
                                           plotOutput(outputId = "classTree", height = 600),
                                           downloadButton('dwn_clTree', 'Download Plot')
                                    )
                                  )
                         ),
                         ### Tab 2
                         tabPanel("Confidence scores",
                                  fluidRow(
                                    column(12,
                                           ## Confidence plot
                                           tags$div(title =
"Same as on previous page, but the cells are colored
by the confidence score of the currently selected node.
If a cell is assigned to the left branch,
the scores are negative (for plotting purposes)
and the colors shades of blue.
For the right branch shades of red are used.",
                                              h3('Confidence scores per nodes')
                                           ),
                                           plotly::plotlyOutput(outputId = "confTsne", height = 600),
                                           downloadButton('dwn_confTsne', 'Download Plot')
                                    )
                                  ),
                                  fluidRow(
                                    column(4,
                                           tags$div(title =
"The classification tree.
Blue cells in the t-SNE plot above are assigned to the blue branches,
the red cells are assigned to the red branches.
The branch that is shown can be changed by 'Choose Node'",
                                              h3('Current branches')
                                           ),
                                           ## Colored cl. tree
                                           plotOutput(outputId = "confTree", height = 600),
                                           downloadButton('dwn_confTree', 'Download Plot')
                                    ),
                                    column(8,
                                           tags$div(title =
"A heatmap of the Profile scores that are used
for the Confidence score calculation.
For an input cell (column), the more strongly the colors/scores differ
between reference types of the two branches,
the more confidence a assignment is.
The branch that is shown can be changed by 'Choose Node'",
                                              h3('Profile score heatmap')
                                           ),
                                           ## Heatmap
                                           plotOutput(outputId = "confHM", height = 600),
                                           tags$div(title =
"Check to sort alphabetically by cell type.
If not checked, cells are sorted by confidence score: 
From highest for the left branch, to highest for the right branch.",
                                           checkboxInput(inputId = "sortByType",
                                                         label = p('Sort by Type', class = 'opt'),
                                                         value = FALSE)),
                                           downloadButton('dwn_confHM', 'Download Plot')
                                    )
                                  )
                         ),
                         ### Tab 3
                         tabPanel("Profile scores",
                                  fluidRow(
                                    column(12,
                                           ## Profile score plots
                                           tags$div( title =
"Same as in the previous tabs,
but the cells are colored by the profile score
of the currently selected reference profile.
Change the selected type by adjusting
the 'Choose Node' and
'Choose Type' buttons",
                                              h3('Profiles scores per nodes per type')
                                           ),
                                           plotly::plotlyOutput(outputId = "profTsne", height = 600),
                                           downloadButton('dwn_profTsne', 'Download Plot')
                                           )
                                  ),
                                  fluidRow(
                                    column(12,
                                           ## Profile scores in boxplots
                                           tags$div(title =
"The same values as above, but in box plots, grouped by the CHETAH cell type.",
                                              h3('In a boxplot')
                                           ),
                                           plotOutput(outputId = "profBox", height = 600),
                                           downloadButton('dwn_profBox', 'Download Plot')
                                    )
                                  ),
                                  fluidRow(
                                    column(12,
                                           ## Tree
                                           tags$div(title =
"The tree, with only the selected reference profile
colored (red if right branch, blue if left)
and the types with which the selected type is compared have the opposite color.
Is a Profile Score high for type X (with Y and Z in the other branch),
than this means that this cell is more likely
to be of type X than of types Y and Z.",
                                              h3('Tree')
                                           ),
                                           plotOutput(outputId = "profTree", height = 600)
                                    )
                                  )
                         ),
                         ### Tab 4
                         tabPanel("Genes used by CHETAH",
                                  fluidRow(
                                    column(12,
                                           ## Gene heatmap
                                           tags$div(title =
"The expression of the genes that were used by CHETAH
for the classification in a heatmap. ,
CHETAH selects a differnt group of genes
for each reference type, in each node.
The cell types to which the current type is compared,
can be viewed in the tree below the heatmap.
Change the selected type by adjusting
the 'Choose Node' and 'Choose Type' buttons
The matrix can be scaled per row (gene), by clicking 'Scale Matrix'.
The number of genes to show can be adjusted by '# of genes' (max = 200).
Automatically, the genes that had the highest difference in the input data will be selected.
To select the genes with the highest difference in the reference data:
check the 'Genes with max. difference in input' box
Both the plot and a list of the selected genes can be downloaded
(buttons below the plot)",
                                              h3("Selected genes per cell type")
                                           ),
                                           plotOutput(outputId = "exprHM", height = 800),
                                           downloadButton('dwn_exprHM', 'Download Plot'),
                                           downloadButton('dwn_genes', 'Download Genes'),
                                           h3("Tree"),
                                           plotOutput(outputId = 'genesTree', height = 600)
                                    )
                                  )
                         ),
                         ### Tab 5
                         tabPanel("Expression per gene",
                                  fluidRow(
                                      column(12,
                                             ## Gene heatmap
                                             tags$div(title =
"Select a gene, for which to plot 
the expression per cell, grouped
and colored per cell type in boxplots",
                                                h3("Gene expression per cell type")
                                             ),
                                             plotOutput(outputId = "geneExpr", height = 400),
                                             downloadButton('dwn_geneExpr', 'Download Plot')
                                      )
                                  )
                          ),
                          ### Tab 6
                          tabPanel("Info",
                                   fluidRow(
                                      column(2),
                                      column(10,
                                         tags$div(style = "right:100px;width:600px;text-align:justify;",
                                           tags$h3('The general method'),
                                           tags$p("CHETAH creates a classifcation tree, by hierarchically clustering the reference data.
                                           CHETAh calculates two types of scores for each input cell j in each node of the classification tree.
                                           First, for each cell j, a Profile Score is calculated for each reference cell type in this node
                                           This Profile Score is a -1:1 value that represents the similarity of j to the reference profile.
                                           Based of these Profile Scores, cell j is assigned to the right or the left branch of the node.
                                           For this assignment, one Confidence Score is calculated. This score (values of 0:2) represents the confidence of the assignment
                                           If the assignment of j has a confidence below the Confidence Threshold, the cell is not assigned to a branch, but for j, the classification will stop in that node.
                                           A classifcation to a non-leaf node are called an 'intermediate type'.
                                           Classifcations to a leaf node of the tree is called a 'final type'.
                                           0.1 is the default Confidence threshold. A threshold of 0 will classify all cells to a final type (leaf node of the tree) and 1 is a very stringent cut-off,
                                           in which case only the cells with very high confidence will be classified."),
                                           tags$br(),
                                           tags$p("Recap: for each cell j, in each node, a Profile Score is calculated for each reference profile, the cell is assigned to a branch, and for this assignment, one Confidence Score is calculated."),
                                           tags$br(),
                                           tags$p("Most plots have a help-message that can be viewed by hovering over the title of the plot.")
                                         )
                                      )
                                   )
                          )
                )
            )
        )
    )
)

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  eval = TRUE
)
knitr::opts_knit$set(
  root.dir = system.file('data', package = 'CHETAH')
)
library(Matrix)
library(CHETAH)

## ----glance, echo=TRUE, eval=FALSE--------------------------------------------
# ## Make SingleCellExperiments
# reference <- SingleCellExperiment(assays = list(counts = ref_counts),
#                                      colData = DataFrame(celltypes = ref_ct))
# 
# input <- SingleCellExperiment(assays = list(counts = input_counts),
#                               reducedDims = SimpleList(TSNE = input_tsne))
# 
# ## Run CHETAH
# input <- CHETAHclassifier(input = input, ref_cells = reference)
# 
# ## Plot the classification
# PlotCHETAH(input)
# 
# ## Extract celltypes:
# celltypes <- input$celltype_CHETAH

## ----bioconductor_inst, echo=TRUE, eval=FALSE---------------------------------
# ## Install BiocManager is necessary
# if (!require("BiocManager")) {
#     install.packages("BiocManager")
# }
# BiocManager::install('CHETAH')
# 
# # Load the package
# library(CHETAH)

## ----github _inst, echo=TRUE, eval=FALSE--------------------------------------
# ## Install BiocManager is necessary
# if (!require("BiocManager")) {
#     install.packages("BiocManager")
# }
# BiocManager::install('CHETAH', version = "devel")
# 
# # Load the package
# library(CHETAH)

## ----prepare_examp, echo=TRUE, eval=TRUE--------------------------------------
## load CHETAH's datasets
data('headneck_ref')
data('input_mel')

## To prepare the data from the package's internal data, run:
celltypes_hn <- headneck_ref$celltypes
counts_hn <- assay(headneck_ref)
counts_melanoma <- assay(input_mel)
tsne_melanoma <- reducedDim(input_mel)

## The input data: a Matrix
class(counts_melanoma)
counts_melanoma[1:5, 1:5]

## The reduced dimensions of the input cells: 2 column matrix
tsne_melanoma[1:5, ]
all.equal(rownames(tsne_melanoma), colnames(counts_melanoma))

## The reference data: a Matrix
class(counts_hn)
counts_hn[1:5, 1:5]

## The cell types of the reference: a named character vector
str(celltypes_hn)
    
## The names of the cell types correspond with the colnames of the reference counts:
all.equal(names(celltypes_hn), colnames(counts_melanoma)) 

## ----make_sce, echo=TRUE, eval=TRUE-------------------------------------------
## For the reference we define a "counts" assay and "celltypes" metadata
headneck_ref <- SingleCellExperiment(assays = list(counts = counts_hn),
                                     colData = DataFrame(celltypes = celltypes_hn))

## For the input we define a "counts" assay and "TSNE" reduced dimensions
input_mel <- SingleCellExperiment(assays = list(counts = counts_melanoma),
                                  reducedDims = SimpleList(TSNE = tsne_melanoma))

## ----run_chetah, echo=TRUE, eval=TRUE-----------------------------------------
input_mel <- CHETAHclassifier(input = input_mel,
                              ref_cells = headneck_ref)

## ----out.width="100%", dpi = 50, fig.height = 6, fig.width = 12---------------
PlotCHETAH(input = input_mel)

## ----out.width="100%", dpi = 50, fig.height = 6, fig.width = 12---------------
PlotCHETAH(input = input_mel, interm = TRUE)

## ----eval=FALSE---------------------------------------------------------------
# colors <- PlotCHETAH(input = input_mel, return_col = TRUE)

## ----eval = FALSE-------------------------------------------------------------
# CHETAHshiny(input = input_mel)

## ----out.width="100%", dpi = 50, fig.height = 6, fig.width = 12---------------
input_mel <- Classify(input = input_mel, 0.8)
PlotCHETAH(input = input_mel, tree = FALSE)

## ----out.width="100%", dpi = 50, fig.height = 6, fig.width = 12---------------
input_mel <- Classify(input_mel, 0)
PlotCHETAH(input = input_mel, tree = FALSE)

## ----out.width="100%", dpi = 50, fig.height = 6, fig.width = 12---------------
input_mel <- RenameBelowNode(input_mel, whichnode = 6, replacement = "T cell")
PlotCHETAH(input = input_mel, tree = FALSE)

## ----out.width="100%", dpi = 50, fig.height = 6, fig.width = 12---------------
input_mel <- Classify(input_mel) ## the same as Classify(input_mel, 0.1)
PlotCHETAH(input = input_mel, tree = FALSE)

## ----eval = FALSE-------------------------------------------------------------
# cell_selection <- unlist(lapply(unique(ref$celltypes), function(type) {
#     type_cells <- which(ref$celltypes == type)
#     if (length(type_cells) > 200) {
#         type_cells[sample(length(type_cells), 200)]
#     } else type_cells
# }))
# ref_new <- ref[ ,cell_selection]

## ----eval = FALSE-------------------------------------------------------------
# assay(headneck_ref, "counts") <- apply(assay(headneck_ref, "counts"), 2, function(column) log2((column/sum(column) * 100000) + 1))

## ----eval = FALSE-------------------------------------------------------------
# ribo <- read.table("~/ribosomal.txt", header = FALSE, sep = '\t')
# headneck_ref <- headneck_ref[!rownames(headneck_ref) %in% ribo[,1], ]

## ----out.width="100%", dpi = 50, fig.height = 6, fig.width = 12---------------
CorrelateReference(ref_cells = headneck_ref)

## ----out.width="100%", dpi = 50, fig.height = 6, fig.width = 12, fig.cap = "In this plot, the rows are the original cell type labels, the columns the labels that were assigned during classification. The colors and sizes of the squares indicate which part of the cells of the row name type are classified to the column type. E.g. 4th row, 2th column shows that 5-10% of CD4 T cells are classified as regulatory T cells."----
ClassifyReference(ref_cells = headneck_ref)

## -----------------------------------------------------------------------------
sessionInfo()

#' A SingleCellExperiment on which CHEATHclassifier is run using the \code{\link{headneck_ref}}
#' It holds subset of the Melanoma data, from Tirosh et al. (2016), Science.
#'
#' @docType data
#' @format This is a SingleCellExperiment
#' @usage data('input_mel')
#' @references Tirosh et al. (2016) Science 6282:189-196
#'
#' @source for the original data: \href{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE72056}{GEO}
"input_mel"

#' A SingleCellExperiment with celltypes in the "celltypes" colData.
#' A subset of the Head-Neck data from Puram et al. (2017) Cancer Cell.
#'
#' @docType data
#' @format A list of expression matrices. Each object is named as the cell type of the cells in that matrix.
#' Each matrix has the cell (names) in the colums and the genes in the rows.
#' @usage data('headneck_ref')
#' @references Puram et al. (2017) Cancer Cell 171:1611-1624
#'
#' @source for the original data: \href{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE103322}{GEO}
"headneck_ref"

## -------------------------------------------------------------------------------------
## ----------------------------------- CHETAH ------------------------------------------
## -- CHaracterization of cEll Types Aided by Hierarchical clustering ------------------
## -------------------------------------------------------------------------------------

#' Identification of cell types aided by hierarchical clustering
#'
#' @description
#' CHETAH classifies an input dataset by comparing it to
#' a reference dataset in a stepwise, top-to-bottom fashion.
#' See 'details' for a full explanation.
#' \emph{NOTE: We recommend to use all the default parameters}
#'
#' @param input \strong{required}: an input SingleCellExperiment.
#' (see: \href{https://bioconductor.org/packages/release/bioc/html/SingleCellExperiment.html}{Bioconductor},
#' and the vignette \code{browseVignettes("CHETAH")})
#' @param ref_cells \strong{required}: A reference SingleCellExperiment, with
#' the cell types in the "celltypes" colData (or otherwise defined in \code{ref_ct}.
#' @param ref_profiles \emph{optional} In case of bulk-RNA seq or micro-arrays,
#' an expression matrix with one (average) reference expression profile
#' per cell type in the columns. (`ref_cells` must be left empty)
#' @param ref_ct the colData of \code{ref_cells} where the cell types are stored.
#' @param input_c the name of the assay of the input to use.
#' \code{NA} (default) will use the first one.
#' @param ref_c same as \code{input_c}, but for the reference.
#' @param thresh the initial confidence threshold, which can be changed after running
#' by \code{\link{Classify}})
#' @param gs_method method for gene selection. In every node of the tree:
#' "fc" = quick method: either a fixed number (\code{n_genes})
#' of genes is selected with the highest fold-change (default),
#' or genes are selected that have a fold-change higher than \code{fc_thresh}
#' (the latter is used when \code{fix_ngenes = FALSE}) . \cr
#' "wilcox": genes are selected based on fold-change (\code{fc_thresh}),
#' percentage of expression (\code{pc_thresh}) and p-values (\code{p_thresh}),
#' p-values are found by the wilcox test.
#' @param cor_method the correlation measure: one of:
#' "spearman" (default), "kendall", "pearson", "cosine"
#' @param clust_method the method used for clustering the reference profiles.
#' One of the methods from \code{\link[stats]{hclust}}
#' @param clust_dist a distance measure, default: \code{\link[bioDist]{spearman.dist}}
#' @param n_genes The number of genes used in every step. Only used if
#' \code{fix_ngenes = TRUE}
#' @param pc_thresh when: \emph{gs_method = "wilcox"}, only genes are selected
#' for which more than a \code{pc_tresh} fraction of a reference group of cells
#' express that gene
#' @param p_thresh when: \emph{gs_method = "wilcox" }, only genes are selected
#' that have a p-value < \code{p_thresh}
#' @param fc_thresh when: \emph{gs_method = "wilcox" or gs_method = "fc"
#' AND fix_ngenes = FALSE},
#' only genes are selected that have a log2 fld-change > \code{fc_thresh}
#' between two reference groups. \cr
#' \strong{if this mode is selected, the reference must be in the log2 space}.
#' @param subsample to prevent reference types with a lot of cells to influence
#' the gene selection, subsample types with more that \code{subsample} cells
#' @param fix_ngenes when: \emph{gs_method = "fc"} use a fixed number of genes
#' for all correlations. when: \emph{gs_method = "wilcox"}
#' use a maximum of genes per step.
#' When \code{fix_ngenes = FALSE & gs_methode = "fc"} \code{fc_thresh}
#' is used to define the fold-change cut-off for gene selection.
#' @param plot.tree Plot the classification tree.
#' @param only_pos \emph{not recommended}: only use genes for a reference type
#' that are higher expressed in that type, than the others in that node.
#' @param print_steps whether the number of genes (postive and negative)
#' per step per ref_cell_type should be printed
#'
#' @return
#' A SingleCellExperiment with added:
#' -  input$celltype_CHETAH
#' a named character vector that can directly be used in any other workflow/method.
#' -  "hidden" `int_colData` and `int_metadata`, not meant for direct interaction, but
#' which can all be viewed and interacted with using: `PlotCHETAH` and `CHETAHshiny`
#' A list containing the following objects is added to input$int_metadata$CHETAH
#' \itemize{
#'   \item \strong{classification} a named vector: the classified types
#'   with the corresponding names of the input cells
#'   \item \strong{tree} the hclust object of the classification tree
#'   \item \strong{nodetypes} A list with the cell types under each node
#'   \item \strong{nodecoor} the coordinates of the nodes of the classification tree
#'   \item \strong{genes} A list per node, containing a list per
#'   reference type with the genes used for the profile scores of that type
#'   \item \strong{parameters} The parameters used
#' }
#' A nested DataFrame is added to input$int_colData$CHETAH.
#' It holds 3 top-levels DataFrames
#' \itemize{
#'   \item \strong{prof_scores} A list with the profile scores
#'   \item \strong{conf_scores} A list with the confidence scores
#'   \item \strong{correlations} A list with the correlations of the
#'   input cells to the reference profiles
#' }
#' @details
#' CHETAH will hierarchically cluster reference data
#' to produce a classification tree (ct).
#' In each node of the ct, CHETAH will
#' assign each input cell to on of the two branches, based on gene selections,
#' correlations and calculation of profile and confidence scores.
#' The assignement will only performed if the confidence score for
#' such an assignment is higher than the Confidence Threshold.
#' If this is not the case, classification for the cell will stop in the current node.
#' Some input cells will reach the leaf nodes of the ct (the pre-defined cell types),
#' these classifications are called \strong{final types}
#' For other cells, assignment will stop in a node. These classifications
#' are called \strong{intermediate types}.  \cr
#' @export
#' @importFrom bioDist spearman.dist
#' @import SingleCellExperiment
#' @importFrom stats as.dendrogram cutree ecdf hclust p.adjust wilcox.test
#' @importFrom S4Vectors DataFrame
#' @importFrom SummarizedExperiment assay assays
#' @examples
#' data('input_mel')
#' data('headneck_ref')
#' ## Melanoma data from Tirosh et al. (2016) Science
#' input_mel
#' ## Head-Neck data from Puram et al. (2017) Cancer Cell
#' headneck_ref
#' input_mel <- CHETAHclassifier(input = input_mel, ref_cells = headneck_ref)
CHETAHclassifier <- function (input,
                              ref_cells =       NULL,
                              ref_profiles =    NULL,
                              ref_ct =          "celltypes",
                              input_c =         NA,
                              ref_c =           NA,
                              thresh =          0.1,
                              gs_method =       c("fc", "wilcox"),
                              cor_method =      c("spearman", "kendall", "pearson", "cosine"),
                              clust_method =    c("average", "single", "complete", "ward.D2", "ward.D", "mcquitty", "median", "centroid"),
                              clust_dist =      bioDist::spearman.dist,
                              n_genes =         200,
                              pc_thresh =       0.2,
                              p_thresh =        0.05,
                              fc_thresh =       1.5,
                              subsample =       FALSE,
                              fix_ngenes =      TRUE,
                              plot.tree =       FALSE,
                              only_pos =        FALSE,
                              print_steps =     FALSE) {
    
    stopifnot(is.logical(plot.tree),
              is.logical(subsample),
              is.logical(only_pos),
              is.numeric(n_genes),
              is.numeric(pc_thresh),
              is.numeric(p_thresh),
              is.numeric(fc_thresh),
              is.numeric(thresh),
              is(clust_dist(matrix(seq_len(4), nrow = 2)), "dist"),
              !(is.null(ref_cells)) | !(is.null(ref_profiles)),
              (is(input, "SingleCellExperiment")),
              if (!is.null(ref_cells)) is(ref_cells, "SingleCellExperiment") else TRUE,
              if (!is.null(ref_profiles)) is(ref_profiles, "SingleCellExperiment") else TRUE)
    cor_method <- match.arg(cor_method)
    gs_method <- match.arg(gs_method)
    clust_method <- match.arg(clust_method)

    if (!is.null(ref_cells)) ref_check <- ref_cells else ref_check <- ref_profiles
    if (0 %in% colnames(ref_check)) { stop("please don't use '0' as a cell type name") }
    if (any(c("", " ") %in% ref_check[[ref_ct]])) stop("The cell types in the references contains an empty type '' or ' '. Please replace with a character string")
    if (!(ref_ct %in% names(SingleCellExperiment::colData(ref_check)))) {
        rc_names = paste(names(SingleCellExperiment::colData(ref_check)), collapse = " ")
        stop("Please add the cell type data in the colData of your reference and supply it's name to 'ref_ct').
              Current colData:", rc_names)
    }; rm(ref_check)
    
    input_c <- TestCHETAH(input = input, input_c = input_c,
                          runBefore = FALSE, object = "input")
    if (!is.null(ref_cells)) {
        ref_c <- TestCHETAH(input = ref_cells, input_c = ref_c,
                            runBefore = FALSE, parameter = "ref_c",
                            object = "ref_cells")
    }
    
    if (is.null(ref_cells)) {
        message("Running without reference cells: classification will only be based on correlations \n")
    }
    message('Preparing data....    \n')
    
    ## Same genes in reference as input & extract cell type names
    if (!is.null(ref_cells)) {
        if (!setequal(rownames(input), rownames(ref_cells))) {
            ref_cells <- EqualGenes(input, ref_cells)
        }
        uniq_ct <- unique(ref_cells[[ref_ct]])
    } else {
        if (!setequal(rownames(input), rownames(ref_profiles))) {
            ref_profiles <- EqualGenes(input, ref_profiles)
        }
        uniq_ct <- unique(ref_profiles[[ref_ct]])
    }
    if (any(grepl("Node", uniq_ct))) {
        stop("Please don't use 'Node' in any cell type name. This is essential for the method to run. Please change, e.g. to lower case 'node'")
    }
    if (any(grepl("Unassigned", uniq_ct))) {
        stop("Please don't use 'Unassigned' in any cell type name. This is essential for the method to run. Please change, e.g. to lower case 'unassigned'")
    }
    
    ## Make reference_profiles (one average profile per reference cell type):
    if (is.null(ref_profiles)) {
        ref_profiles <- MeanRef(ref = ref_cells, method = "mean", ref_ct = ref_ct, ref_c = ref_c)
    } else if (is(ref_profiles, "SingleCellExperiment")) {
        ref_profiles <- SummarizedExperiment::assay(ref_profiles, ref_c)
    }
    
    ## Make ref_types
    if (!is.null(ref_cells)) {
        ref_types <- ref_cells[[ref_ct]]
        names(ref_types) <- colnames(ref_cells)
    } else {
        ref_types <- NULL
    }
    
    ## Make an environment to store the classification information and variables in
    Env <- new.env(parent = emptyenv())
    variables <- list(nodeheigths = c(), ##the heights of the different tree nodes, for plotting convenience
                      profilescores = S4Vectors::DataFrame(initial = rep(NA, ncol(input))), # a list of the profile scores per node
                      nodetypes = list(), # a list of the reference cell types per node
                      correlations = S4Vectors::DataFrame(initial = rep(NA, ncol(input))), # a list of the input correlations per node
                      confidencescores = S4Vectors::DataFrame(initial = rep(NA, ncol(input))), # a list of the confidence scores per node
                      genes = list(), # The gene names that are used in each node
                      counter = 0, # to keep track of the node depth/number
                      tree = NULL, # will be filled with the classification tree
                      p_thresh = p_thresh, # the p-value threshold for wilcox
                      fc_thresh = fc_thresh, # the fold-change threshold for wilcox (or fc, when fix_ngenes = FALSE)
                      pc_thresh = pc_thresh, # the % of expression threshold for wilcox
                      fix_ngenes = fix_ngenes, # boolean, use a fixed number of genes?
                      subsample = subsample, # boolean, subsample ref_types, to min(table(ref_types))
                      only_pos = only_pos, # use only higher expressed genes
                      clust_dist = clust_dist, # clustering distance
                      cor_method = cor_method, # correlation method
                      gs_method = gs_method, # gene selection method (fold-change ('fc'), or wilcox)
                      print_steps = print_steps, # print the number of selected genes in each step?
                      clust_method = clust_method, # clustering method
                      n_genes = n_genes, # number of genes used, if fix_ngenes = TRUE
                      input_c = input_c,
                      ref_c = ref_c)
    Env <- list2env(variables, envir = Env)
    
    ## Calculate the profile and confidence scores in each node
    message('Running analysis... \n')
    SplitNodes(Env = Env, # the environment
               input = input, # the input expression matrix
               ref_cells = ref_cells, ## matrix of all reference cells
               ref_types = ref_types, ## types of the ref_cells matrix
               ref_profiles =  ref_profiles) ## matrix of the average reference profiles per cell type
    
    ## For plotting purposes, find the x coordinates of the nodes of the classification tree
    heights <- Env$nodeheigths
    hc <- Env$tree
    coor <- cbind("y" = heights, "x" = rep(NA, length(heights)))
    coordinates <- dendextend::get_nodes_xy(as.dendrogram(hc))
    coordinates <- coordinates[coordinates[,2] != 0, ,drop = FALSE]
    coor[ ,2] <- coordinates[,1][match(coor[ ,1], coordinates[ ,2])]
    
    ## Remove the initial columns of the DataFrames
    colnames(Env$profilescores) <- paste0("Node", seq_len(length(Env$profilescores)) - 1)
    colnames(Env$confidencescores) <- paste0("Node", seq_len(length(Env$confidencescores)) - 1)
    colnames(Env$correlations) <- paste0("Node", seq_len(length(Env$correlations)) - 1)
    
    ## Remove with only bulk profiles
    if (is.null(ref_cells)) {
        Env$profilescores <- NULL
        Env$confidencescores <- NULL
    }
    
    ## Define output
    parameters <- list(available.types = colnames(ref_profiles),
                       n_genes = n_genes,
                       cor_method = cor_method,
                       clust_method = clust_method,
                       clust_dist = clust_dist,
                       thresh = thresh,
                       subsample = subsample,
                       only_pos = only_pos,
                       pc_thresh = pc_thresh,
                       p_thresh = p_thresh,
                       fc_thresh = fc_thresh,
                       gs_method = gs_method,
                       fix_ngenes = fix_ngenes)
    
    ## Add hidden meta-data
    SingleCellExperiment::int_colData(input)$CHETAH <- S4Vectors::DataFrame(prof_scores = rep(NA, ncol(input)))
    SingleCellExperiment::int_colData(input)$CHETAH$prof_scores <- Env$profilescores
    SingleCellExperiment::int_colData(input)$CHETAH$conf_scores <- Env$confidencescores
    SingleCellExperiment::int_colData(input)$CHETAH$correlations <- Env$correlations
    
    ## Add the general metadata
    SingleCellExperiment::int_metadata(input)$CHETAH <- list(nodetypes = Env$nodetypes,
                                                             tree = hc,
                                                             nodecoor = coor,
                                                             genes = Env$genes,
                                                             parameters = parameters,
                                                             input_c = input_c)
    
    ## Add the (visible) classification meta-data
    input <- Classify(input = input, thresh = thresh)
    
    if (plot.tree) PlotTree(input = input)
    return(input)
    }     ### CHETAHclassifier
## -----------------------------------------------------------------------------

# Called by the CHETAHclassifier. Determines the branches
# of the current node of the classification tree,
# calls ScoreNode and reruns itself on the next-higher node(s).
# The fact that this function is recursive,
# makes it possible to do all calculations from top to bottom
SplitNodes <- function (input, Env, ref_profiles, ref_cells, ref_types) {
    
    ## Keep track of the number of the current node
    Env$counter <- Env$counter + 1
    
    ## (Re)construct the classification tree and cut at the highest node
    hc <- hclust(Env$clust_dist(t(ref_profiles)), method = Env$clust_method)
    branches <- cutree(hc, k = 2)
    
    ## Get the names of the celltypes in the two branches and save
    branch1 <- names(branches[branches == 1])
    branch2 <- names(branches[branches == 2])
    Env$nodetypes[[Env$counter]] <- branches
    Env$nodeheigths[Env$counter] <- max(hc$height)
    if (Env$counter == 1) Env$tree <- hc
    if (Env$print_steps) message("Left node: ", branch1, "\nRight node: ", branch2, "\n")
    
    ## Calculate correlations, profile and confidence scores
    ScoreNode(branch1 = branch1,
              branch2 = branch2,
              input = input,
              Env = Env,
              ref_profiles = ref_profiles,
              ref_cells = ref_cells,
              ref_types = ref_types)
    
    ## If a branch contains 2 or more cell types (and thus other nodes),
    ## perform the steps in the lower nodes
    if (length(branch1) > 1) {
        SplitNodes(ref_profiles = ref_profiles[ ,branch1],input = input, Env = Env,
                   ref_cells = ref_cells, ref_types = ref_types)
    }
    if (length(branch2) > 1) {
        SplitNodes(ref_profiles = ref_profiles[ ,branch2], input = input, Env = Env,
                   ref_cells = ref_cells, ref_types = ref_types)
    }
}      ### SplitNodes
## -----------------------------------------------------------------------------

# Called by the CHETAHclassifier via SplitNode.
# Does the actual gene selections and correlations
# and calculates confidence scores.
ScoreNode <- function  (ref_profiles, branch1, branch2, input, Env, ref_cells, ref_types) {
    leaves <- c(branch1, branch2)
    Env$genes[[Env$counter]] <- list()
    
    ##################### First, gene selection and correlations are done for each reference cell type
    for (uniquetype in seq_len(length(leaves))) {
        
        ## save names of cell types in the same branch and cell types in the other branch
        current_type <- leaves[uniquetype]
        branch <- if(current_type %in% branch1) branch1 else branch2
        oth_branch <- if(current_type %in% branch1) branch2 else branch1
        
        ## Subsample types with many cells.
        if (!is.null(ref_cells)) {
            current_cells <- names(ref_types[ref_types %in% current_type])
            
            if (Env$subsample) {
                min_group_size <- min(table(ref_types[ref_types %in% oth_branch]))
                otherbranch_c <- c()
                for(i in seq_len(length(oth_branch))) {
                    cells <- names(ref_types[ref_types %in% oth_branch[i]]) ## ob == "other branch"
                    if (length(cells) > min_group_size ) {
                        cells <- cells[sample(length(cells), min_group_size)]
                    }
                    otherbranch_c <- c(otherbranch_c, cells)
                }
            } else {
                otherbranch_c <- names(ref_types[ref_types %in% oth_branch])
            }
        }
        
        ## select genes that are differentially expressed
        ## between current type and the other branch
        if (Env$gs_method == "wilcox" & !is.null(ref_cells)) {
            genes <- doWilcox(current_cells = current_cells,
                              otherbranch_c = otherbranch_c,
                              ref_cells = ref_cells,
                              Env = Env)
        } else {
            genes <- FindDiscrGenes(ref_profiles = ref_profiles,
                                    type = current_type,
                                    other_branch = oth_branch,
                                    Env = Env)
        }
        Env$genes[[Env$counter]][[current_type]] <- genes
        genes <- names(genes)
        
        ## Correlate to the reference cell type using the just selected genes
        if (Env$cor_method == "cosine") {
            correlations <- doCosine(genes = genes,
                                     input = input,
                                     ref_cells = ref_cells,
                                     current_cells = current_cells,
                                     otherbranch_c = otherbranch_c,
                                     ref_profiles = ref_profiles,
                                     type = current_type,
                                     Env = Env)
        } else {
            correlations <- doCorrelation(ref_profiles = ref_profiles,
                                          genes = genes,
                                          input = input,
                                          ref_cells = ref_cells,
                                          current_cells = current_cells,
                                          otherbranch_c = otherbranch_c,
                                          type = current_type,
                                          Env = Env)
        }
        ## correlation of input cells to the current reference profile (RP)
        cor_i <- correlations[["cor_i"]]
        ## correlation of reference cells of current type to RP
        cor_t <- correlations[["cor_t"]]
        ## correlation of reference cells in the other branch to RP
        cor_ob <- correlations[["cor_ob"]]
        
        ## produce the profile scores
        if(!is.null(ref_cells)) {
            good <- ecdf(cor_t)
            false <- ecdf(cor_ob)
            goodvalues <- good(cor_i) ; names(goodvalues) <- colnames(input)
            falsevalues <- (1 - false(cor_i)) ; names(falsevalues) <- colnames(input)
            profile_score <- goodvalues - falsevalues
        } else profile_score <- NA
        
        ## Add the profile scores and correlations of all types to one matrix
        if (uniquetype == 1) prof_scores <- S4Vectors::DataFrame(profile_score) else {
            prof_scores <- cbind(prof_scores, profile_score)
        }
        if (uniquetype == 1) cors <- S4Vectors::DataFrame(cor_i) else cors <- cbind(cors, cor_i)
        
    } ########### End of correlations per reference type
    
    if(Env$print_steps) message("\n")
    
    colnames(cors) <- leaves
    if (!is.null(prof_scores)) colnames(prof_scores) <- leaves
    
    ## Calculate confidence scores
    if(!is.null(ref_cells)) {
        for(type_number in seq_len(length(leaves))) {
            
            ## Select type
            type <- leaves[type_number]
            
            ## Calculate the final confidence scores
            if(type %in% branch1) {
                prof_scores_ob <- apply(prof_scores[ ,branch2, drop = FALSE], 1, mean)
            } else {
                prof_scores_ob <- apply(prof_scores[ ,branch1, drop = FALSE], 1, mean)
            }
            confidence <- prof_scores[ ,type_number] - prof_scores_ob
            
            ## save confidence score
            if (type_number == 1) conf_scores <- S4Vectors::DataFrame(confidence) else {
                conf_scores <- cbind(conf_scores, confidence)
            }
        }
        colnames(conf_scores) <- leaves
    } else conf_scores <- NA
    
    ## Save all the info of this step
    Env$confidencescores[[Env$counter]] <- conf_scores
    Env$correlations[[Env$counter]] <- cors
    Env$profilescores[[Env$counter]] <- prof_scores
    
}    ### ScoreNode
## -----------------------------------------------------------------------------
# Used by ScoreNode to do the gene selection, only based on fld-change between two groups of cells
FindDiscrGenes <- function (type, other_branch, ref_profiles, Env) {
    
    ## Calculate mean
    group1 <- apply(ref_profiles[ , type, drop = FALSE], 1, mean)
    group2 <- apply(ref_profiles[ , other_branch, drop = FALSE], 1, mean)
    group_diff <- group1-group2
    if (!Env$only_pos) {
        gd <- group_diff
        group_diff <- abs(group_diff)
    }
    
    ## select the genes
    if(!Env$fix_ngenes){
        pnn_genes <- group_diff
        pn_genes <- pnn_genes[pnn_genes > Env$fc_thresh]
        fc_thresh <- Env$fc_thresh
        while (length(pn_genes) == 0) {
            fc_thresh <- fc_thresh*0.5
            pn_genes <- pnn_genes[pnn_genes > fc_thresh]
        }
        pp_genes <- sum(pn_genes > 0)
        if (fc_thresh != Env$fc_thresh) message("decreased fc_thresh to", fc_thresh, '   ')
        if(Env$print_steps) message("|", length(pn_genes), "/", pp_genes, "|")
    } else {
        pn_genes <- sort(group_diff, decreasing = TRUE)[seq_len(Env$n_genes)]
        top <- sort(group_diff, decreasing = TRUE)[seq_len(Env$n_genes)]
        pn_genes <- rep(1, length(top))
        names(pn_genes) <- names(top)
        if (!Env$only_pos) pn_genes[gd[names(pn_genes)] < 0] <- 0
        # Print the number of selected genes
        if(Env$print_steps) message("|", length(pn_genes), "/", sum(pn_genes), "|")
    }
    
    return(pn_genes)
}        ### FindDiscrGenes

## -----------------------------------------------------------------------------
# Used by ScoreNode to do the gene selections using the Wilcox test
doWilcox <- function (current_cells, otherbranch_c, ref_cells, Env) {
    
    ## First calculate the fld change and percentage of cells expressing the gene, per gene.
    fld <- apply(SummarizedExperiment::assay(ref_cells, Env$ref_c), 1, function (z) {
        mean(z[current_cells]) - mean(z[otherbranch_c])
    })
    pct1 <- apply(SummarizedExperiment::assay(ref_cells, Env$ref_c), 1, function (z) {
        sum(z[current_cells] > 0) / length(current_cells)
    })
    pct2 <- apply(SummarizedExperiment::assay(ref_cells, Env$ref_c), 1, function (z) {
        sum(z[otherbranch_c] > 0) / length(otherbranch_c)
    })
    
    ## Take only the genes in the ref_cells that exceed the fld and pct thresholds
    ## To prevent no genes exceeding the threshold, increase the threshold if necessary when needed
    fc_thresh <- Env$fc_thresh
    if(Env$only_pos) {
        testgenes  <- SummarizedExperiment::assay(ref_cells, Env$ref_c)[((pct1 > Env$pc_thresh |
                                                                              pct2 > Env$pc_thresh) &
                                                                             fld > fc_thresh), , drop = FALSE]
        while (nrow(testgenes) < 3) {
            fc_thresh <- 0.5 * fc_thresh
            testgenes <- SummarizedExperiment::assay(ref_cells, Env$ref_c)[((pct1 > Env$pc_thresh |
                                                                                 pct2 > Env$pc_thresh) &
                                                                                (fld > fc_thresh)), , drop = FALSE]
        }
    } else {
        testgenes <- SummarizedExperiment::assay(ref_cells, Env$ref_c)[((pct1 > Env$pc_thresh |
                                                                             pct2 > Env$pc_thresh) &
                                                                            (fld > fc_thresh |
                                                                                 fld < -fc_thresh)), , drop = FALSE]
        fc_thresh <- Env$fc_thresh
        while (nrow(testgenes) < 3) {
            fc_thresh <- 0.5 * fc_thresh
            testgenes <- SummarizedExperiment::assay(ref_cells, Env$ref_c)[((pct1 > Env$pc_thresh |
                                                                                 pct2 > Env$pc_thresh) &
                                                                                (fld > fc_thresh |
                                                                                     fld < -fc_thresh)), , drop = FALSE]
        }
    }
    if (fc_thresh != Env$fc_thresh) message("decreased fc_thresh to", log2(fc_thresh), '   ')
    
    ## Wilcox test + p-adjustment & select the genes
    pval <- apply(testgenes, 1, function (z) {
        wtest <- wilcox.test(x = z[current_cells], y = z[otherbranch_c])
        wtest$p.value
    })
    pval[is.na(pval)] <- 1
    pval <- p.adjust(pval, method = "bonferroni", n=length(pval))
    
    genes <- names(pval)[pval < Env$p_thresh]
    
    ## To prevent no genes exceeding the threshold, increase the threshold if necessary when needed
    p_thresh <- Env$p_thresh
    while (length(genes) == 0) {
        p_thresh <- p_thresh * 10
        genes <- names(pval)[pval < p_thresh]
    }
    if (p_thresh != Env$p_thresh) message("p-val increased to", p_thresh, '   ')
    
    ## which genes are higher expressed and which lower
    pn_genes <- rep(0, length(genes))
    names(pn_genes) <- genes
    pn_genes[fld[genes] > 0] <- 1
    
    ## Print the number of selected genes
    if (Env$print_steps) message("|", length(pn_genes), "/", sum(pn_genes), "|")
    
    return(pn_genes)
}    ## doWilcox
## -----------------------------------------------------------------------------
# Used by ScoreNode to do the correlations using cosine
doCosine <- function(genes, input, ref_cells, current_cells,
                     otherbranch_c, ref_profiles, type, Env) {
    ## matrices with selected genes + cells
    cells_i <- SummarizedExperiment::assay(input, Env$input_c)[genes, , drop = FALSE]
    cells_t <- ref_profiles[genes, type, drop = FALSE]
    
    ## Do cosine
    t_vs_t <- drop(crossprod(cells_t,cells_t))
    cor_i <-  drop(crossprod(cells_t,cells_i)/sqrt(diag(crossprod(cells_i,cells_i)) * t_vs_t))
    cor_i[is.na(cor_i)] <- 0
    
    names(cor_i) <- colnames(input)
    
    if(!is.null(ref_cells)) {
        ## same steps for type and other branch
        cells_b <- ref_cells[genes , current_cells, drop = FALSE]
        cells_ob <- ref_cells[genes , otherbranch_c, drop = FALSE]
        cor_t <-  drop(crossprod(cells_t,cells_b)/
                           sqrt(diag(crossprod(cells_b,cells_b)) * t_vs_t))
        cor_ob <- drop(crossprod(cells_t,cells_ob)/
                           sqrt(diag(crossprod(cells_ob,cells_ob)) * t_vs_t))
        cor_t[is.na(cor_t)] <- 0
        cor_ob[is.na(cor_ob)] <- 0
        names(cor_t) <- current_cells
        names(cor_ob) <- otherbranch_c
    } else {
        cor_t <- NULL
        cor_ob <- NULL
    }
    
    data <- list(cor_i, cor_t, cor_ob)
    names(data) <- c("cor_i", "cor_t", "cor_ob")
    return(data)
}     ##doCosine
## -----------------------------------------------------------------------------
# Used by ScoreNode to do the correlations (if Env$cor_method != cosine)
doCorrelation <- function(ref_profiles, genes, input, ref_cells,
                          current_cells, otherbranch_c, type, Env) {
    ## as.matrix: in cases were a sparse Matrix is used
    ## suppressWarnings: suppress warnings when the sd is 0 and cor returns a/some NA(s)
    cor_i <-   suppressWarnings(cor(as.matrix(SummarizedExperiment::assay(input, Env$input_c)[genes, , drop = FALSE]),
                                    as.matrix(ref_profiles[genes, type, drop = FALSE]),
                                    method = Env$cor_method))
    cor_i[is.na(cor_i)] <- 0
    names(cor_i) <- colnames(input)
    
    if(!is.null(ref_cells)) {
        cor_t <- suppressWarnings(cor(as.matrix(SummarizedExperiment::assay(ref_cells, Env$ref_c)[genes , current_cells, drop = FALSE]),
                                      as.matrix(ref_profiles[genes, type, drop = FALSE]),
                                      method = Env$cor_method))
        cor_ob <- suppressWarnings(cor(as.matrix(SummarizedExperiment::assay(ref_cells, Env$ref_c)[genes , otherbranch_c, drop = FALSE]),
                                       as.matrix(ref_profiles[genes, type, drop = FALSE]),
                                       method = Env$cor_method))
        cor_t[is.na(cor_t)] <- 0
        cor_ob[is.na(cor_ob)] <- 0
        names(cor_t) <- current_cells
        names(cor_ob) <- otherbranch_c
    } else {
        cor_t <- NULL
        cor_ob <- NULL
    }
    
    data <- list(cor_i, cor_t, cor_ob)
    names(data) <- c("cor_i", "cor_t", "cor_ob")
    return(data)
}     ## doCorrelation
## -----------------------------------------------------------------------------
#' (Re)classify after running \code{\link{CHETAHclassifier}} using a confidence threshold \cr
#' NOTE: In case of bulk reference profiles: only the correlations will be used,
#' as the data does not allow for profile or confidence scores to be calculated.
#'
#' @param input a SingleCellExperiment on which \code{\link{CHETAHclassifier}} has been run
#' @param thresh a confidence threshold between -0 and 2. \cr
#' Selecting 0 will classify all cells, whereas 2 will result i
#' n (almost) no cells to be classified. \cr
#' \emph{recommended}: between 0.1 (fairly confident) and 1 (very confident)
#' @param return_clas Instead of returning the SingleCellExperiment, only return the classification vector
#' @return
#' a charachter vector of the cell types with the names of the cells
#' @export
#' @examples
#' data('input_mel')
#' data('headneck_ref')
#' ## Classify all cells
#' input_mel <- Classify(input_mel, 0)
#'
#' ## Classify only cells with a very high confidence
#' input_mel <- Classify(input_mel, 1)
#'
#' ## Back to the default
#' input_mel <- Classify(input_mel)
#'
#' ## Return only the classification vector
#' celltypes <- Classify(input_mel, 1, return_clas = TRUE)
Classify <- function(input, thresh = 0.1, return_clas = FALSE) {
    TestCHETAH(input = input)
    
    chetah_data <- SingleCellExperiment::int_colData(input)$CHETAH
    nodetypes <- SingleCellExperiment::int_metadata(input)$CHETAH$nodetypes
    
    ## Get parameters
    if(!is.null(chetah_data$conf_scores)) { ### TODO check this with profile scores only
        conf <- chetah_data$conf_scores
        prof <- chetah_data$prof_scores
    } else {
        conf <- NULL
        prof <- chetah_data$correlations
    }
    ## Run over the tree
    classification <- nodeDown(conf = conf, prof = prof, node = 1,
                               thresh = thresh, nodetypes = nodetypes)
    names(classification) <- rownames(prof[[1]])
    input$celltype_CHETAH <- classification
    if (return_clas) return(classification) else return(input)
}

## ---------------------------------
# To make a profile_matrix from a list of reference matrices
MeanRef <- function (ref,
                     method = "mean",
                     scale = 10000,
                     log = FALSE,
                     ref_ct,
                     ref_c) {
    
    if (!(method == "mean" | method == "median")) {
        stop ("method must be either mean or median")
    }
    
    ref_means <- list()
    for(type_sl in unique(ref[[ref_ct]])) {
        new <- apply(SummarizedExperiment::assay(ref[ ,ref[[ref_ct]] == type_sl], ref_c), 1, method)
        ref_means[[type_sl]] <- new
    }
    ref_means <- do.call(cbind, ref_means)
    colnames(ref_means) <- unique(ref[[ref_ct]])
    rownames(ref_means) <- rownames(ref)
    ## return
    return(ref_means)
}              ## MeanRef
## ---------------------------------------------------------------------------------------------------------------------------

#' Plots the chetah classification tree with nodes numbered
#'
#' @param input a SingleCellExperiment on which \code{\link{CHETAHclassifier}} has been run
#' @param col a vector of colors, with the names of the reference cell types
#' @param col_nodes a vector of colors, ordered for node 1 till the last node
#' @param return instead of printing, return the ggplot object
#' @param no_bgc remove the background color from the node numbers
#' @param plot_limits define the % of the plot_heigth that should be used as a margin below and above the plot
#' Decreasing the former further is usefull when the labels are cut of the plot (default = c(-0,25, 01)).
#' @param labelsize the size of the intermediate and leaf node labels (default = 6)
#' @return
#' A ggplot object of the classification tree
#' @export
#' @import ggplot2
#' @importFrom dendextend color_branches
#' @importFrom dendextend color_labels
#' @importFrom stats as.dendrogram
#' @examples 
#' data('input_mel')
#' PlotTree(input = input_mel)
PlotTree <- function(input, col = NULL,
                     col_nodes = NULL,
                     return = FALSE,
                     no_bgc = FALSE,
                     plot_limits = c(-0.4, 0.1),
                     labelsize = 6) {
    TestCHETAH(input = input)
    ## Extract parameters + make dendrogram
    meta_data <- input@int_metadata$CHETAH
    lbls <- meta_data$tree$labels
    ord <- meta_data$tree$order
    meta_data$tree$labels <- paste0(meta_data$tree$labels, "  ")
    hc <- as.dendrogram(meta_data$tree)
    hc <- dendextend::set(hc, 'labels_cex', labelsize/6)
    
    ## Give colors
    if(!is.null(col)) {
        col1 <- col[lbls[ord]]
        hc <- dendextend::color_branches(hc, clusters = seq_len(length(lbls)), col = col1)
        hc <- dendextend::color_labels(hc, col = col1)
    }
    if(!is.null(col_nodes)) {
        col_n <- col_nodes[grepl("Node", names(col_nodes))]
        names(col_n) <- gsub("Node", "", names(col_n))
        col_n <- col_n[order(as.numeric(names(col_n)))][seq_len(nrow(meta_data$nodecoor)) - 1]
        col_n <- c(col_nodes[grepl("Unassigned", names(col_nodes))], col_n)
        names(col_n)[1] <- 0
        col_r <- col_n
        alpha1 <- 0.2
    } else {
        col_n <- rep("black", nrow(meta_data$nodecoor))
        col_r <- "white"
        alpha1 <- 0.8
    }
    if(no_bgc) {
        col_r <- "white"
        alpha1 <- 0.8
    }
    
    ## Extract additional parameters
    maxh <- max(dendextend::get_branches_heights(hc))
    length <- length(labels(hc))
    
    ## Plot
    ggdend <- ggplot(hc) +
        annotate(geom = "rect",
                 xmin = meta_data$nodecoor[, "x"] - 0.02*length,
                 xmax = meta_data$nodecoor[, "x"] + 0.02*length,
                 ymin = meta_data$nodecoor[, "y"] - 0.05*maxh,
                 ymax = meta_data$nodecoor[, "y"] + 0.05*maxh,
                 fill = col_r, alpha = alpha1) +
        annotate(geom = "text",
                 x = meta_data$nodecoor[, "x"],
                 y = meta_data$nodecoor[, "y"],
                 label = c(0, seq_len(nrow(meta_data$nodecoor) - 1)),
                 size = labelsize, fontface = "bold",
                 col = col_n) +
        ylim(plot_limits[1]*maxh, maxh+plot_limits[2]*maxh) +
        ggtitle("Classification Tree")
    
    ## Delete layer that gives warnings
    keep <- !unlist(lapply(ggdend$layers, function(x) is(x$geom, "GeomPoint")))
    ggdend$layers <- ggdend$layers[keep]
    if (return) return(ggdend) else suppressWarnings(print(ggdend))
}   ## PlotTree
## -----------------------------------------------------------
#' Plots a variable on a t-SNE
#'
#' @param toplot the variable that should be plotted. Either a character vector
#' or a factor, or a (continuous) numeric.
#' If toplot is not named with the rownames of \code{redD}, it is assumed
#' that the order of the two is the same.
#' @param input a SingleCellExperiment on which \code{\link{CHETAHclassifier}} has been run
#' @param redD the name of the reducedDim of the input to use for plotting
#' @param col a vector of colors. If \code{toplot} is a numeric,
#' this will become a continuous scale. \cr
#' \emph{If \code{toplot} is a charachter vector, the colors should
#' be named with the unique values (/levels) of toplot}
#' @param return instead of printing, return the ggplot object
#' @param limits the limits of the continuous variable to plot.
#' When not provided the minimal and maximal value will be used
#' @param pt.size the point-size
#' @param shiny Needed for the shiny application: should always be NULL
#' @param y_limits the y-axis limits
#' @param x_limits the x-axis limits, if NULL
#' @param legend_label the label of the legend
#' @return
#' A ggplot object
#' @export
#' @import ggplot2
#' @examples
#' data('input_mel')
#' CD8 <- assay(input_mel)['CD8A', ]
#' PlotTSNE(toplot = CD8, input = input_mel)
PlotTSNE <- function (toplot, input, redD = NA, col = NULL, return = FALSE,
                      limits = NULL, pt.size = 1, shiny = NULL,
                      y_limits = NULL, x_limits = NULL, legend_label = '') {
    redD <- TestCHETAH(input = input, redD = redD)
    redDname <- redD
    redD <- SingleCellExperiment::reducedDim(input, redD)
    ## Merge redD and toplot
    if (is.null(names(toplot)) & is.null(dim(toplot))) names(toplot) <- rownames(redD)
    toplot <- data.frame(toplot, stringsAsFactors = TRUE)
    if (!is.null(shiny) & ncol(toplot) == 2) colnames(toplot)[2] <- 'key'
    toplot$rn <- rownames(toplot)
    colnames(toplot)[1] <- "variable"
    redD <- data.frame(redD)
    redD$rn <- rownames(redD)
    colnames(redD) <- c(paste0(redDname, c("_1", "_2")), "rn")
    Dim1 <- colnames(redD)[1]
    Dim2 <- colnames(redD)[2]
    data <- merge(toplot, redD, by = "rn")
    
    ## Initial plot
    if (!is.null(shiny)) {
        text <- paste0('cell_label: ', data$rn, '<br>', data$shiny, data$variable)
        if ('key' %in% colnames(data)) text <- paste0(text, '<br>','cell type: ', data$key)
        data$text <- text
        plot <- ggplot(data, aes(x=Dim1, y=Dim2, text = text))
    } else {
        plot <- ggplot(data, aes_string(x=Dim1, y=Dim2))
    }
    plot <- plot +
        theme_classic() +
        geom_point(aes_string(color = 'variable'), size = pt.size) +
        labs(color = legend_label) +
        theme(legend.text = element_text(size=10),
              legend.title = element_text(size=10))
    
    class <- class(toplot[,1])
    
    # For a categorical variable:
    if(class == "factor") {
        plot <- plot +
            guides(colour = guide_legend(override.aes = list(size = 2.5*pt.size),
                                         ncol = 1, title = legend_label))
        if (!is.null(col)) plot <- plot + scale_color_manual(values = col)
    }
    
    # For a numeric variable:
    if(class == "numeric" | class == 'integer') {
        if (is.null(limits)) {
            limits <- c(min(toplot[,1])-(0.01*min(toplot[,1])),
                        max(toplot[,1])+(0.01*max(toplot[,1])))
        }
        if (is.null(col)) {
            col <- c(colorpanel(n = 50, low = '#2f2bad', mid = '#93cfe2', high = '#fffaaa'),
                     colorpanel(n = 50, low = '#fffaaa', mid = "#ffad66", high = '#d60000'))
        }
        plot <- plot +
            scale_color_gradientn(colors = col, limits = limits)
    }
    
    ## Define plotting limits
    if (!is.null(x_limits)) {
        plot <- plot + lims(x = c(x_limits[1]-(0.01*x_limits[1]), x_limits[2]+(0.01*x_limits[2]))) }
    if (!is.null(y_limits)) {
        plot <- plot + lims(y = c(y_limits[1]-(0.01*y_limits[1]), y_limits[2]+(0.01*y_limits[2]))) }
    if (return) return(plot) else print(plot)
}
## ----------------------------------------------------------------------------
# Plot boxplots grouped by a class variable
PlotBox <- function(toplot, class, col = NULL, grad_col = NULL,
                    limits = NULL, return = FALSE) {
    
    toplot <- data.frame(toplot)
    class <- data.frame(class, stringsAsFactors = TRUE)
    col <- col[levels(class[,1])]
    
    if (is.null(limits)) {
        limits <- c(min(toplot[,1])-0.01, max(toplot[,1])+0.01)
    }
    data <- cbind.data.frame(toplot, class)
    colnames(data) <- c("score", "class")
    
    ## Plot basics + background
    plot <- ggplot(data, aes_string(x = 'class', y = 'score')) +
        geom_hline(yintercept = 0, color = "gray80") +
        theme_classic() +
        theme(axis.text.x = element_text(angle = 60, hjust = 1, size = 10)) +
        labs(color = "cell types") +
        xlab("cell types") +
        ylab("score") +
        ylim(low = limits[1], high = limits[2]) +
        coord_flip()
    
    ## background jitter (value per cell, scattered on the x-axis)
    if (!is.null(col)) plot <- plot + scale_color_manual(values = col)
    if (is.null(grad_col)) {
        plot <- plot + geom_jitter(aes_string(color = 'class'), size = 0.1)
    } else {
        plot <- plot +
            geom_jitter(aes_string(fill = 'score'),
                        size = 0.1, shape = 21, color = grDevices::rgb(0,0,0,0)) +
            scale_fill_gradientn(colors = grad_col, limits = c(-2,2))
    }
    ## Add the boxplot
    plot <- plot  + geom_boxplot(aes_string(color = 'class'),
                                 fill = grDevices::rgb(1,1,1, 0.6), outlier.colour="NA")
    
    if (return) return(plot) else print(plot)
}
## -------------------------------------------------------------------------------------
#' Plot the CHETAH classification on 2D visulization like t-SNE
#' + the corresponding classification tree,
#' colored with the same colors
#'
#' @param input a SingleCellExperiment on which \code{\link{CHETAHclassifier}} has been run
#' @param redD the name of the reducedDim of the input to use for plotting
#' @param interm color the intermediate instead of the final types
#' @param tree plot the tree, along with the classification
#' @param pt.size the point-size of the classication plot
#' @param return_col whether the colors that are used for
#' the classification plot should be returned
#' @param col custom colors for the cell types. \emph{the colors
#' should be named with the corresponding cell types}
#' @param return return the plot instead of printing it
#' @return a ggplot object
#' @export
#' @importFrom cowplot plot_grid
#' @importFrom grDevices rainbow rgb
#' @examples
#' data('input_mel')
#' #' ## Standard plot (final types colored)
#' PlotCHETAH(input = input_mel)
#'
#' ## Intermediate types colored
#' PlotCHETAH(input = input_mel, interm = TRUE)
#'
#' ## Plot only the t-SNE plot
#' PlotCHETAH(input = input_mel, tree = FALSE)
PlotCHETAH <- function(input, redD = NA, interm = FALSE, return = FALSE,
                       tree = TRUE, pt.size = 1, return_col = FALSE, col = NULL) {
    TestCHETAH(input = input)
    ## Determine colors: if not custom, use the predefined ones. If too many cell types: rainbow.
    meta_data <- input@int_metadata$CHETAH
    classification <- input$celltype_CHETAH
    if(is.null(col)) {
        colors <- c ('blue', 'gold', 'cyan3', 'navy',
                     'forestgreen', 'orange', 'darkolivegreen3',
                     'brown', 'green', 'purple','deepskyblue', 'cyan',
                     'orangered3', 'coral', 'yellow3', "black",
                     'yellow1', 'darkorchid1', 'darksalmon', 'darkseagreen1',
                     'darkslategrey', 'deeppink4', 'green2', 'lemonchiffon1',
                     'lightcyan', 'midnightblue', 'maroon1', 'orange3', 'palegreen',
                     'palevioletred1', 'peru', 'seagreen1', 'red3', 'snow2',
                     'steelblue1', 'turquoise')
        leaf_nodes <- names(meta_data$nodetypes[[1]])
        int_nodes <- c("Unassigned", paste0("Node", seq_len(length(meta_data$nodetypes))))
        
        ## Add other names, in case user renamed types
        extra_nodes <- unique(classification)[!(unique(classification) %in% names(meta_data$nodetypes[[1]]))]
        extra_nodes <- extra_nodes[!(extra_nodes %in% int_nodes)]
        if (length(extra_nodes) > 0) leaf_nodes <- c(leaf_nodes, extra_nodes)
        M <- max(length(int_nodes), length(leaf_nodes))
        if (M < 24)   {
            gray <- paste0('gray', rev(seq(2, 92, 4)))
        } else if (M < 47) {
            gray <- paste0('gray', rev(seq(2, 92, 2)))
        } else {
            gray <- rep('gray70', M)
        }
        if (M > 36) colors <- grDevices::rainbow(M)
        
        ## color either the final, or intermediate types
        if(!interm) {
            names(colors) <- leaf_nodes
            names(gray) <- int_nodes
        } else {
            names(colors) <- int_nodes
            names(gray) <- leaf_nodes
        }
        col <- c(gray, colors)
        col <- col[!is.na(names(col))]
    } else col <- col
    
    ## Plot
    toplot <- classification
    u_toplot <- unique(toplot)
    toplot <- factor(toplot, levels = c(sort(u_toplot[!grepl("Node|Unassigned", u_toplot)]),
                                        u_toplot[grepl("Unassigned", u_toplot)],
                                        sort(u_toplot[grepl("Node", u_toplot)])))
    plot1 <- PlotTSNE(toplot = toplot, input = input, redD = redD,
                      col = col, return = TRUE, pt.size = pt.size)
    if(!interm) plot2 <- PlotTree(input, col, return = TRUE)
    if(interm) plot2 <- PlotTree(input, col_nodes = col, no_bgc = TRUE, return = TRUE)
    if (tree) {
        plots <- cowplot::plot_grid(plot1, plot2, ncol = 2)
    } else plots <- plot1
    if (return) return(plots) else print(plots)
    if (return_col) return(col)
}
## ----------------------------------------------------------------------------------------
#' Correlate all reference profiles to each other
#' using differentially expressed genes.
#'
#' @param ref_cells the reference, similar to
#' \code{\link{CHETAHclassifier}}'s ref_cells
#' @param ref_profiles similar to
#' \code{\link{CHETAHclassifier}}'s ref_profiles
#' @param ref_c the assay of \code{ref_cells} to use
#' @param ref_ct the colData of \code{ref_cells} where the cell types are stored.
#' @param return return the matrix that was used to produce the plot
#' @param n_genes as in \code{\link{CHETAHclassifier}}
#' @param fix_ngenes as in \code{\link{CHETAHclassifier}}
#' @param print_steps as in \code{\link{CHETAHclassifier}}
#' @param only_pos as in \code{\link{CHETAHclassifier}}
#' @return
#' A square plot. The values show how much two reference profiles
#' correlate, when using the genes with the highest fold-change.
#'
#' @export
#'
#' @importFrom corrplot corrplot
#' @importFrom SummarizedExperiment assay assays
#' @importFrom stats cor
#' @examples
#' data('headneck_ref')
#' CorrelateReference(ref_cells = headneck_ref)
CorrelateReference <- function(ref_cells = NULL, ref_profiles = NULL, ref_ct = "celltypes",
                               ref_c = NA, return = FALSE, n_genes = 200,
                               fix_ngenes = TRUE, print_steps = FALSE,
                               only_pos = FALSE) {
    message('Running... in case of 1000s of cells, this may take a couple of minutes \n')
    ref_c <- TestCHETAH(input = ref_cells, input_c = ref_c,
                        runBefore = FALSE, parameter = "ref_c",
                        object = "ref_cells")    ## Make ref_profiles
    if (is.null(ref_profiles)) {
        ref_profiles <- MeanRef(ref = ref_cells, method = "mean", ref_ct = ref_ct, ref_c = ref_c)
    } else if (is(ref_profiles, "SingleCellExperiment")) {
        ref_profiles <- SummarizedExperiment::assay(ref_profiles, ref_c)
    }
    
    ## Make empty correlation matrix
    cors <- matrix(NA, nrow = ncol(ref_profiles), ncol = ncol(ref_profiles))
    rownames(cors) <- colnames(ref_profiles)
    colnames(cors) <- colnames(ref_profiles)
    Env <- list('n_genes' = n_genes, 'only_pos' = only_pos,
                'print_steps' = print_steps, 'fix_ngenes' = fix_ngenes)
    
    ## Do the pair-wise correlations
    for(i in seq_len(ncol(ref_profiles))) {
        for(j in seq_len(ncol(ref_profiles))) {
            if (i == j) cors[i,j] <- 1 else {
                if (!is.na(cors[j,i])) cors[i,j] <- cors[j,i] else {
                    genes <- names(FindDiscrGenes(type = colnames(ref_profiles)[i],
                                                  other_branch = colnames(ref_profiles)[j],
                                                  ref_profiles = ref_profiles,
                                                  Env = Env))
                    
                    corr <- cor(ref_profiles[genes,i, drop = FALSE],
                                ref_profiles[genes, j, drop = FALSE],
                                method = "spearman")
                    cors[i,j] <- corr
                }
            }
        }
    }
    ## plot
    cols <- c(colorpanel(n = 10, low = '#2f2bad', mid = '#93cfe2', high = '#fffdd3'),
              colorpanel(n = 10, low = '#fffdd3', mid = "#ffad66", high = '#d60000'))
    corrplot::corrplot(cors, method = "square", order = "hclust",
                       col = cols, mar = c(0, 0, 2, 0), type = 'upper')
    
    if (return) return(cors)
} ## CorrelateReference
## ----------------------------------------------------------------------------------------
#' Use a reference dataset to classify itself.
#' A good reference should have almost no mixture
#' between reference cells.
#'
#' @param ref_cells the reference, similar to
#' \code{\link{CHETAHclassifier}}'s ref_cells
#' @param ref_ct the colData of \code{ref_cells} where the cell types are stored.
#' @param ref_c same as \code{input_c}, but for the reference.
#' @param return return the matrix that was used to produce the plot
#' @param ... Other variables to pass to
#' \code{\link{CHETAHclassifier}}
#' @return
#' A square plot. The rows are the original cell types,
#' the columns the classifion labels.
#' The colors and sizes of the squares indicate which
#' part of the cells of the rowname type are
#' classified to the type of the column name.
#' On the left of the plot, the percentage of cells
#' that is classified to an intermediate type
#' is plotted.
#' A good reference would classify nearly 100% of cells of type A to type A.
#' @export
#'
#' @importFrom corrplot corrplot
#' @importFrom graphics text
#' @examples
#' data('headneck_ref')
#' ClassifyReference(ref_cells = headneck_ref)
ClassifyReference <- function(ref_cells, ref_ct = "celltypes",
                              ref_c = "counts",
                              return = FALSE, ...) {
    ## Classify
    input <- CHETAHclassifier(input = ref_cells,
                              ref_cells = ref_cells,
                              ref_ct = ref_ct,
                              ref_c = ref_c,
                              input_c = ref_c,
                              ...)
    
    ## Make the correlation matrix
    ref_types <- ref_cells[[ref_ct]]
    names(ref_types) <- colnames(ref_cells)
    nms <- unique(ref_types)
    lngt <- length(nms)
    type <- input$celltype_CHETAH
    splt <- unique(type)
    splt <- splt[grepl("Node|Unassigned", splt)]
    cors <- matrix(NA, nrow = lngt, ncol = lngt+1)
    rownames(cors) <- nms
    colnames(cors) <- c(nms, 'Nodes')
    
    ## Extract the percentages
    for(i in seq_len(lngt)) {
        for(j in seq_len(lngt)) {
            actual <- names(ref_types)[ref_types == nms[i]]
            cors[i,j] <- sum(type[actual] == nms[j])/length(actual)
        }
    }
    
    ## Extract the percentage that ended up in a node
    for(i in seq_len(lngt)) {
        actual <- names(ref_types)[ref_types == nms[i]]
        cors[i,lngt+1] <- sum(grepl("Node|Unassigned", type[actual]))/length(actual)
    }
    
    ## Plot
    cols <- c(rep('black', 20),
              colorpanel(n = 10, low = '#2f2bad', mid = '#93cfe2', high = '#fffdd3'),
              colorpanel(n = 10, low = '#fff6b5', mid = "#ffad66", high = '#d60000'))
    a <- corrplot::corrplot(cors[ ,seq_len(lngt)], method = "square", order = "hclust",
                            col = cols, col.lim = c(0,1), mar = c(0, 0, 2, 0))
    text(-5.5, seq_len(nrow(cors)), labels = round(cors[ ,'Nodes'], 2)[rev(rownames(cors))])
    text(-5.5, nrow(cors)+1, '(%) in nodes')
    
    if (return) return(cors)
} ## ClassifyReference
## ----------------------------------------------------------------------------------
nodeDown <- function(conf, prof, node, thresh, nodetypes, prev_clas = NULL) {
    
    ## Do the classification of this node
    prof_df <- as.matrix(prof[[node]]) ## approximately 400x faster than on DataFrame
    conf_df <- as.matrix(conf[[node]])
    sub_clas <- apply(prof_df, 1, which.max)
    sub_clas  <- colnames(prof[[node]])[sub_clas]
    if (!is.null(conf)) {
        sub_score <- c()
        for (row in seq_len(nrow(conf_df))) {
            sub_score <- c(sub_score, conf_df[row, sub_clas[row]])
        }
        if (node == 1) {
            sub_clas[sub_score < thresh] <- "Unassigned"
        } else {
            sub_clas[sub_score < thresh] <- paste0("Node", (node -1))
        }
    }
    ## Only apply on cells reaching this node
    if(!is.null(prev_clas)) {
        reclas <- prev_clas %in% names(nodetypes[[node]])
        sub_clas[!reclas] <- prev_clas[!reclas]
    }
    ## continue to next node, or return
    if(node != length(prof)){
        nodeDown(conf = conf,
                 node = node + 1,
                 thresh = thresh,
                 nodetypes = nodetypes,
                 prof = prof,
                 prev_clas = sub_clas)
    } else {
        return(sub_clas)
    }
}
## -------------------------------------------------------------------------
## select the common genes of the input and the reference
EqualGenes <- function(inp, ref) {
    common <- intersect(rownames(inp), rownames(ref))
    if (length(common) == 0) {
      ref_examp = paste0(rownames(ref)[seq_len(10)],  ", ")
      input_examp = paste0(rownames(inp)[seq_len(10)], ", ")
        stop("Non of the genes names (rownames) in the reference: ", ref_examp,
             "\noverlapped with those of the input:", input_examp,
             "\n Make sure you are using the same type of gene ids (ensemble, symbol, etc) for both datasets.")
    }
    ref <- ref[common, ]
}
### ---------------------------------------------------------------------------
## Select all the final AND intermediate types below a node
SelectNodeTypes <- function (input, whichnode) {
    nodet <- input@int_metadata$CHETAH$nodetypes
    nodes <- unlist(lapply(nodet[(whichnode):length(nodet)], function (x) {
        all(names(x) %in% names(nodet[[whichnode ]]))
    }))
    nodes <- paste0('Node', ((whichnode - 1):(length(nodet) - 1))[nodes])
    nodes[grepl("Node0", nodes)] <- "Unassigned"
    alltypes <- c(nodes, names(nodet[[whichnode]]))
    return(alltypes)
}
### ---------------------------------------------------------------------------
#' In the CHETAH classification, replace the name of a Node
#' and all the names of the final and intermediate types under that Node.
#'
#' @param input a SingleCellExperiment on which \code{\link{CHETAHclassifier}} has been run
#' @param whichnode the number of the Node
#' @param replacement a character vector that replaces the names under the selected Node
#' @param nodes_exclude \emph{optional} the names of the types that should  \strong{NOT} be replaced
#' @param types_exclude \emph{optional} numbers of the Nodes under the selected Node, that should \strong{NOT} be replaced
#' @param node_only only rename the Node itself, without affecting the types under that Node
#' @param return_clas Instead of returning the SingleCellExperiment, only return the classification vector
#'
#' @return
#' The SingleCellExperiment with the new classification or if `return_clas = TRUE` the classification vector.
#' @export
#'
#' @examples
#' ## In the example data replace all T-cell subtypes by "T cell"
#' data('input_mel')
#' #' input_mel <- RenameBelowNode(input = input_mel, whichnode = 7, replacement = "T cell")
RenameBelowNode <- function(input, whichnode, replacement,
                            nodes_exclude = NULL,
                            types_exclude = NULL,
                            node_only = FALSE,
                            return_clas = FALSE) {
    classification <- input$celltype_CHETAH
    nodename <- paste0("Node", whichnode)
    nodename[grepl("Node0", nodename)] <- "Unassigned"
    whichnode <- whichnode + 1
    if (node_only) {
        classification[classification == nodename] <- replacement
    } else {
        replace <- SelectNodeTypes(input = input, whichnode = whichnode)
        if (!is.null(nodes_exclude)) {
            exclude <- vector()
            for (number in seq_len(length(nodes_exclude))) {
                exclude <- c(exclude, SelectNodeTypes(input = input, whichnode = nodes_exclude[number]))
            }
            replace <- replace[!(replace %in% exclude)]
        }
        if (!is.null(types_exclude)) {
            replace <- replace[!(replace %in% types_exclude)]
        }
        classification[classification %in% replace] <- replacement
        input$celltype_CHETAH <- classification
        if (return_clas) return(classification) else return(input)
    }
}
### -----------------
ch_env <- new.env(parent = emptyenv())
### ---------------------------------------------------------------------------
## Package environment to transfer the data for the shiny package
#' Launch a web page to interactively go trough the classification
#'
#' @param input a SingleCellExperiment on which \code{\link{CHETAHclassifier}} has been run
#' @param redD the name of the reducedDim of the input to use for plotting
#' @param input_c the name of the assay of the input to use.
#' \code{NA} (default) will use the first one.
#' @importFrom plotly renderPlotly plotlyOutput ggplotly event_data
#' @import shiny
#' @importFrom pheatmap pheatmap
#' @importFrom reshape2 melt
#' @return
#' Opens a web page in your default browser
#' @export
CHETAHshiny <- function (input, redD = NA, input_c = NA) {
    
    ## Search for the shinyApp in the package directory
    saved.stringsAsFactors <- options()$stringsAsFactors
    options(stringsAsFactors = TRUE)
    appDir <- system.file("shinyApp", "App", package = "CHETAH")
    if (appDir == "") {
        stop("Could not find example directory. Try re-installing `chetah`.", call. = FALSE)
    }
    ## Put data in package_environment
    input_c <- TestCHETAH(input = input, input_c = input_c)
    redD <- TestCHETAH(input = input, redD = redD)
    ch_env$redD <- redD
    ch_env$input_c <- input_c
    ch_env$chetah <- input
    rm(input)
    shiny::runApp(appDir, display.mode = "normal")
    options(stringsAsFactors=saved.stringsAsFactors)
}

### ---------------------------------------------------------------------------
TestCHETAH <- function (input, redD = NULL, input_c = NULL, runBefore = TRUE, parameter = NULL, object = "input") {
    
    ## is chetah run?
    if (runBefore) {
        if (is.null(input@int_metadata$CHETAH)) stop('Please run CHETAHclassifier on the SingleCellExperiment object before calling this funtion')
    }
    ## Select the correct reducedDim/assay
    if (!is.null(redD)) {
        if (is.null(parameter)) parameter <- "redD"
        selected <- TestInput(input = input, assessor = SingleCellExperiment::reducedDims,
                              name = "reducedDims", parameter = parameter, selected = redD, object = object)
        if (!setequal(rownames(SingleCellExperiment::reducedDim(input, selected)), colnames(input))) {
            stop("Please provide a data.frame in ReducedDims that has the same rownames as the colnames of the assays", call. = FALSE)
        }
        
        return(selected)
    } else if (!is.null(input_c)) {
        if (is.null(parameter)) parameter <- "input_c"
        selected <- TestInput(input = input, assessor = SummarizedExperiment::assays,
                              name = "assays", parameter = parameter, selected = input_c, object = object)
        return(selected)
    }
}
### ---------------------------------------------------------------------------
TestInput <- function (input, assessor, name, parameter, selected, object) {
    
    ## Test if assessor(object) is named
    if (!is.null(names(assessor(input))) & !("" %in% names(assessor(input))[1])) {
        if (length(assessor(input)) == 0) {
            stop("No ", name, " in the SingleCellExperiment object. ",
                 "Please refer to the CHETAH vignette on how to prepare your data: browseVignettes('CHETAH')")
        }
        if (is.na(selected)) {
            selected <- names(assessor(input))[1]
        } else {
            if (!(selected %in% names(assessor(input)))) {
              ass_names = paste(names(assessor(input)), collapse = " ")
                stop("The specified ", parameter ," is not available. ",
                      "Please choose one of 'names(", name, "(", object, "))': ",
                       ass_names, call. = FALSE)
            }
        }
        return(selected)
    } else {
        stop("Please name your: '", name, "(", object, "))'. This is essential for the method")
    }
}

### ---------------------------------------------------------------------------
colorpanel = function (n, low, mid, high) {
  # function from the CRAN gplots package. gtools is orphaned, so reused the code
  # see: cran.r-project.org/web/packages/gplots/
  if (missing(mid) || missing(high)) {
    low <- grDevices::col2rgb(low)
    if (missing(high)) 
      high <- grDevices::col2rgb(mid)
    else high <- grDevices::col2rgb(high)
    red <- seq(low[1, 1], high[1, 1], length = n)/255
    green <- seq(low[3, 1], high[3, 1], length = n)/255
    blue <- seq(low[2, 1], high[2, 1], length = n)/255
  }
  else {
    isodd <- n %% 2 == 1
    if (isodd) {
      n <- n + 1
    }
    low <- grDevices::col2rgb(low)
    mid <- grDevices::col2rgb(mid)
    high <- grDevices::col2rgb(high)
    lower <- floor(n/2)
    upper <- n - lower
    red <- c(seq(low[1, 1], mid[1, 1], length = lower), seq(mid[1, 
                                                                1], high[1, 1], length = upper))/255
    green <- c(seq(low[3, 1], mid[3, 1], length = lower), 
               seq(mid[3, 1], high[3, 1], length = upper))/255
    blue <- c(seq(low[2, 1], mid[2, 1], length = lower), 
              seq(mid[2, 1], high[2, 1], length = upper))/255
    if (isodd) {
      red <- red[-(lower + 1)]
      green <- green[-(lower + 1)]
      blue <- blue[-(lower + 1)]
    }
  }
  rgb(red, blue, green)
}

context("Plots")
data("headneck_ref")
data("input_mel")
test_that("return colors", { 
    expect_is(PlotCHETAH(input_mel, return_col = TRUE), "character")
})
test_that("plotchetah output", {
    vdiffr::expect_doppelganger("plot: standard chetah", PlotCHETAH(input_mel))
    vdiffr::expect_doppelganger("plot: intermediate types", PlotCHETAH(input = input_mel, interm = TRUE))
    vdiffr::expect_doppelganger("plot: tree only", PlotCHETAH(input = input_mel, tree = FALSE))
    vdiffr::expect_doppelganger("plot: rename below", {
        chetah_rb <- RenameBelowNode(input = input_mel, whichnode = 6, replacement = "TCELL")
        PlotCHETAH(input = chetah_rb, tree = FALSE)
    })
    vdiffr::expect_doppelganger("plot: reclassify", {
        chetah_reclass <- Classify(input = input_mel, thresh = 0.5)
        PlotCHETAH(input = chetah_reclass, tree = FALSE)
    })
})

context("Classifier")
data("headneck_ref")
data("input_mel")

chetah <- CHETAHclassifier(input = input_mel, ref_cells = headneck_ref)

test_that("Output classes", {
    expect_is(chetah@int_metadata$CHETAH$nodetypes, "list")
    expect_is(chetah@int_metadata$CHETAH$tree, "hclust")
    expect_is(chetah@int_metadata$CHETAH$nodecoor, "matrix")
    expect_is(chetah@int_metadata$CHETAH$nodecoor, "matrix")
    expect_is(chetah@int_metadata$CHETAH$genes, "list")
    expect_is(chetah@int_metadata$CHETAH$parameters, "list")
    expect_is(chetah@int_metadata$CHETAH$input_c, "character")
    expect_is(chetah@int_colData$CHETAH$prof_scores, "DataFrame")
    expect_is(chetah@int_colData$CHETAH$conf_scores, "DataFrame")
    expect_is(chetah@int_colData$CHETAH$correlations, "DataFrame")
    expect_is(chetah$celltype_CHETAH, "character")
})

test_that("Output consistency", {
    expect_equal(colnames(chetah@int_colData$CHETAH$correlations), colnames(chetah@int_colData$CHETAH$prof_scores))
    expect_equal(colnames(chetah@int_colData$CHETAH$prof_scores), colnames(chetah@int_colData$CHETAH$prof_scores))
    expect_equal(nrow(chetah@int_colData$CHETAH$prof_scores), ncol(chetah))
    expect_equal(names(chetah$celltype_CHETAH), colnames(chetah))
    expect_true(all(chetah$celltype_CHETAH %in% c(names(chetah@int_metadata$CHETAH$nodetypes[[1]]), 
                                      colnames(chetah@int_colData$CHETAH$prof_scores), 
                                      "Unassigned")))
})





    

---
title: "Introduction to the CHETAH package"
author: "Jurrian de Kanter"
date: "`r Sys.Date()`"
output: 
  html_document:
    number_sections: TRUE
    toc: TRUE
    theme: united
    includes:
     before_body: header.html
vignette: >
  %\VignetteIndexEntry{Introduction to the CHETAH package}  
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  eval = TRUE
)
knitr::opts_knit$set(
  root.dir = system.file('data', package = 'CHETAH')
)
library(Matrix)
library(CHETAH)
```

<style type = "text/css">
h1, .h1 {margin-top: 60px; color: #fcb42c;}
h2, .h2 {margin-top: 30px;}
a {color: #ff7f00;}
div.blue { background-color: #fffaf2; border-radius: 5px; padding: 5px;}
.main-container {
  max-width: 700px;
  margin-left: auto;
  margin-right: auto;
  </style>

# Introduction
__CHETAH (CHaracterization of cEll Types Aided by Hierarchical classification) is a package for cell type identification of single-cell RNA-sequencing (scRNA-seq) data.__   
A pre-print of the article describing CHETAH is available at [bioRxiv](https://www.biorxiv.org/content/10.1101/558908v1).  

Summary: Cell types are assigned by correlating the input data to a reference in a hierarchical manner. This creates the possibility of assignment to intermediate types if the data does not allow to fully classify to one of the types in the reference. CHETAH is built to work with scRNA-seq references, but will also work (with limited capabilities) with RNA-seq or micro-array reference datasets. 
So, to run CHETAH, you will only need: 
    
  * your input data
  * a reference dataset, annotated with cell types
    + Both as a `SingleCellExperiment`

## At a glance
To run chetah on an input count matrix `input_counts` with t-SNE^1^ coordinates in `input_tsne`, and a reference count matrix `ref_counts` with celltypes vector `ref_ct`, run:  

```{r glance, echo=TRUE, eval=FALSE}
## Make SingleCellExperiments
reference <- SingleCellExperiment(assays = list(counts = ref_counts),
                                     colData = DataFrame(celltypes = ref_ct))

input <- SingleCellExperiment(assays = list(counts = input_counts),
                              reducedDims = SimpleList(TSNE = input_tsne))

## Run CHETAH
input <- CHETAHclassifier(input = input, ref_cells = reference)

## Plot the classification
PlotCHETAH(input)

## Extract celltypes:
celltypes <- input$celltype_CHETAH
```
  
__A tumor micro-environment reference dataset containing all major cell types for tumor data can be downloaded:__ [here](https://figshare.com/s/aaf026376912366f81b6). This reference can be used for all (tumor) input datasets.

# Some background
CHETAH constructs a classification tree by hierarchically clustering the reference data. The classification is guided by this tree. In each node of the tree, input cells are either assigned to the right, or the left branch. A confidence score is calculated for each of these assignments. When the confidence score for an assignment is lower than the threshold (default = 0.1), the classification for that cell stops in that node.  

This results in two types of classifications:
  
 * __final types__: Cells that are classified to one of the leaf nodes of the tree (i.e. a cell type of the reference).
 * __intermediate types__: Cells that had a confidence score lower than the threshold in a certain node are assigned to that intermediate node of the tree. This happens when a cell has approximately the same similarity to the cell types in right and the left branch of that node.
<div class = "blue"> CHETAH generates generic names for the intermediate types: "Unassigned" for cells that are classified to the very first node, and "Node1", "Node2", etc for the additional nodes </div>

# Installation
CHETAH will be a part of Bioconductor starting at release 2.9 (30th of April), and will be available by:
```{r bioconductor_inst, echo=TRUE, eval=FALSE}
## Install BiocManager is necessary
if (!require("BiocManager")) {
    install.packages("BiocManager")
}
BiocManager::install('CHETAH')

# Load the package
library(CHETAH)
```
    
    
The development version can be downloaded from the development version of Bioconductor (in R v3.6).
```{r github _inst, echo=TRUE, eval=FALSE}
## Install BiocManager is necessary
if (!require("BiocManager")) {
    install.packages("BiocManager")
}
BiocManager::install('CHETAH', version = "devel")

# Load the package
library(CHETAH)
```

# Preparing your data
## Required data
If you have your data stored as `SingleCellExperiments`, continue to [the next step](#sce).
Otherwise, you need the following data before you begin:

  * input scRNA-seq count data of the cells to be classified
    + a data.frame or matrix, with cells in the columns and genes in the rows
  * (!) normalized scRNA-seq count data of reference cells
    + in similar format as the input
  * the cell types of the reference cells
    + a named character vector (names corresponding to the colnames of the reference counts)
  * (optional) a 2D reduced dimensional representation of your input data for visualization:
  e.g. t-SNE^1^, PCA.
    + a two-column matrix/data.frame, with the cells in the rows and the two dimensions in the columns

As an example on how to prepare your data, we will use melanoma input data from [Tirosh et al.](10.1126/science.aad0501) 
and head-neck tumor reference data from [Puram et al.](10.1016/j.cell.2017.10.044) as an example.

<div class = "blue"> For information on how to create your own reference see [Creating a Reference](#ref-prep) </div>
<br>    
```{r prepare_examp, echo=TRUE, eval=TRUE}
## load CHETAH's datasets
data('headneck_ref')
data('input_mel')

## To prepare the data from the package's internal data, run:
celltypes_hn <- headneck_ref$celltypes
counts_hn <- assay(headneck_ref)
counts_melanoma <- assay(input_mel)
tsne_melanoma <- reducedDim(input_mel)

## The input data: a Matrix
class(counts_melanoma)
counts_melanoma[1:5, 1:5]

## The reduced dimensions of the input cells: 2 column matrix
tsne_melanoma[1:5, ]
all.equal(rownames(tsne_melanoma), colnames(counts_melanoma))

## The reference data: a Matrix
class(counts_hn)
counts_hn[1:5, 1:5]

## The cell types of the reference: a named character vector
str(celltypes_hn)
    
## The names of the cell types correspond with the colnames of the reference counts:
all.equal(names(celltypes_hn), colnames(counts_melanoma)) 
```

## `SingleCellExperiments` {#sce}
CHETAH expects data to be in the format of a `SingleCellExperiment`,
which is an easy way to store different kinds of data together.
Comprehensive information on this data type can be found [here](https://bioconductor.org/packages/release/bioc/html/SingleCellExperiment.html).

A `SingleCellExperiment` holds three things:

  * counts: `assays`
    - as a `list` of `Matrices`
  * meta-data: `colData`
    - as `DataFrames`
  * reduced dimensions (e.g. t-SNE, PCA): `ReducedDims`
    - as a `SimpleList` of 2-column `data.frames` or `matrices`

CHETAH needs 

  * a reference `SingleCellExperiment` with:
    + an assay
    + a colData column with the corresponding cell types (default "celltypes")
  * an input `SingleCellExperiment` with:
    + an assay
    + a reducedDim (e.g. t-SNE)

For the example data, we would make the two objects by running:  
  
```{r make_sce, echo=TRUE, eval=TRUE}
## For the reference we define a "counts" assay and "celltypes" metadata
headneck_ref <- SingleCellExperiment(assays = list(counts = counts_hn),
                                     colData = DataFrame(celltypes = celltypes_hn))

## For the input we define a "counts" assay and "TSNE" reduced dimensions
input_mel <- SingleCellExperiment(assays = list(counts = counts_melanoma),
                                  reducedDims = SimpleList(TSNE = tsne_melanoma))
```

<div class = "blue"> Note: CHETAH functions default to the first `assay`/`reducedDim` in an object and "celltypes" for the reference's `colData`. See ?CHETAHclassifier and ?PlotCHETAH on how to change this behaviour. </div>

# Running CHETAH
Now that the data is prepared, running chetah is easy:

```{r run_chetah, echo=TRUE, eval=TRUE}
input_mel <- CHETAHclassifier(input = input_mel,
                              ref_cells = headneck_ref)
```

## The output
CHETAH returns the input object, but added:

  * input$celltype_CHETAH
    + a named character vector that can directly be used in any other workflow/method.
  * "hidden" `int_colData` and `int_metadata`, not meant for direct interaction, but
    + which can all be viewed and interacted with using: `PlotCHETAH` and `CHETAHshiny`
    

## Standard plots
CHETAH's classification can be visualized using: `PlotCHETAH`.
This function plots both the classification tree and the t-SNE (or other provided reduced dimension) map.  
Either the  __final types__ or the __intermediate types__ are colored in these plots. The non-colored types are represented in a grayscale.
  
To plot the __final types__:

```{r out.width="100%", dpi = 50, fig.height = 6, fig.width = 12}
PlotCHETAH(input = input_mel)
```
  
<div class = "blue"> Please note that each type "NodeX" corresponds to the node with number X and that the type "Unassigned" corresponds to the node 0  </div>
<br>
  
Conversely, to color the __intermediate types__:

```{r out.width="100%", dpi = 50, fig.height = 6, fig.width = 12}
PlotCHETAH(input = input_mel, interm = TRUE)
```

If you would like to use the classification, and thus the colors, in another package (e.g. Seurat^2^), you can extract the colors using:

```{r eval=FALSE}
colors <- PlotCHETAH(input = input_mel, return_col = TRUE)
```

## `CHETAHshiny`
The classification of CHETAH and other outputs like profile and confidence scores can be 
visualized in a shiny application that allows for 
easy and interactive analysis of the classification.

Here you can view:

  * the confidence of all assignments
  * the classification in an interactive window
  * the genes used by CHETAH, an it's expression in the input data
  * a lot more

The following command will open the shiny application as in an R window. The page can also be opened in your default web-browser by clicking "Open in Browser" at the very top.

```{r eval = FALSE}
CHETAHshiny(input = input_mel)
```
  
# Changing classification
## Confidence score
CHETAH calculates a confidence score for each assignment of an input cell to one of the branches of a node.  
The confidence score:  

 * has a value between 0 and 2
 * will normally lie between 0 and 1
 * 0 represents no confidence for an assignment, 1 high confidence.  
 
__The default confidence threshold of CHETAH is 0.1.__   
This means that whenever a cell is assigned to a branch and the confidence of that assignment is lower than 0.1, the classification will stop in that node.  
   
__The confidence threshold can be adjusted in order to classify more or fewer cells to a final type:__

 * Using a confidence threshold of 0 will classify all input cells to a final type. Be aware that this classification can be noisy and can contain incorrect classifications.  
 * Using a threshold of 0.2, 0.3, 0.4, etc, will classify a decreasing number of cells to a final type, with the remaining cells having a increasingly high confidence throughout all nodes in the tree.  
  

For example, to only classify cells with very high confidence:
```{r out.width="100%", dpi = 50, fig.height = 6, fig.width = 12}
input_mel <- Classify(input = input_mel, 0.8)
PlotCHETAH(input = input_mel, tree = FALSE)
```

Conversely, to classify all cells:
```{r out.width="100%", dpi = 50, fig.height = 6, fig.width = 12}
input_mel <- Classify(input_mel, 0)
PlotCHETAH(input = input_mel, tree = FALSE)
```
  
## Renaming types
For renaming types in the tree, CHETAH comes with the `RenameBelowNode` function.
This can be interesting when you are more interested in the general types, type in the different __intermediate__ and __final types__. 

For the example data, let's say that we are not interested in all the different subtypes of T-cells (under Node6 and Node7), 
we can name all these cells "T cells" by running:

```{r out.width="100%", dpi = 50, fig.height = 6, fig.width = 12}
input_mel <- RenameBelowNode(input_mel, whichnode = 6, replacement = "T cell")
PlotCHETAH(input = input_mel, tree = FALSE)
```

To reset the classification to its default, just run `Classify` again:

```{r out.width="100%", dpi = 50, fig.height = 6, fig.width = 12}
input_mel <- Classify(input_mel) ## the same as Classify(input_mel, 0.1)
PlotCHETAH(input = input_mel, tree = FALSE)
```

# Creating a reference {#ref-prep}
  
## Step 0: Obtain a reference.  

 * Download or use one of your own scRNA-seq datasets, for which cell type labels are available.
   + A tumor micro-environment reference dataset containing all major cell types for tumor data can be downloaded [here](https://figshare.com/s/aaf026376912366f81b6)
 * Make a `SingleCellExperiment` object, as explained [above](#sce)
   
## Step 1: good reference characteristics
CHETAH can use any scRNA-seq reference, but the used reference greatly influences the classification.  
The following general rules apply on choosing and creating a reference:

 * Better results can be achieved by using a reference and an input dataset that are from the same biological type, or at least consist of cells that are in the same cell state. E.g. for an input dataset of PBMCs, a bone marrow reference dataset could be used, but as these cells are more naive or precursor cells, this might negatively influence the classification. In this case, another PBMC dataset would work optimally.
 * The annotation of the reference directly influences the classification. The more accurate the cell type labels, the better the classification. Also, discard any cells that are doublets, contaminations, etc.
 * The sparser the reference data, the more reference cells are needed to create a reliable reference. For high coverage Smart-Seq2^3^ data, as little as 10-20 cells are needed per cell type. For sparser 10X Genomics data, 100+ cells normally gives optimal results.  
 
<div class = "blue"> To reduce computation time with very big references, first try to subsample each cell type to 100-200 cells. CHETAH should have very similar performance to using all cells. For a `SingleCellExperiment` "ref" with cell type metadata "celltypes", this could be done by:
```{r, eval = FALSE}
cell_selection <- unlist(lapply(unique(ref$celltypes), function(type) {
    type_cells <- which(ref$celltypes == type)
    if (length(type_cells) > 200) {
        type_cells[sample(length(type_cells), 200)]
    } else type_cells
}))
ref_new <- ref[ ,cell_selection]
```
</div>  

## Step 1: normalization
CHETAH does not require normalized input data, but __the reference data has to be normalized beforehand__. The reference data that is used in this vignette is already normalized. __Only for sake of the example__, we use this dataset anyway to perform nomalization:

```{r, eval = FALSE}
assay(headneck_ref, "counts") <- apply(assay(headneck_ref, "counts"), 2, function(column) log2((column/sum(column) * 100000) + 1))
```

## Step 2: discaring of house-keeping genes
Certainly with reference with relatively high drop-out rates, CHETAH can be influenced by highly expressed, and thus highly variable, genes.
In our experience, mainly ribosomal protein genes can cause such an effect. We therefore delete these genes, using the "ribosomal" list from [here](https://figshare.com/s/aaf026376912366f81b6)  
 
```{r, eval = FALSE}
ribo <- read.table("~/ribosomal.txt", header = FALSE, sep = '\t')
headneck_ref <- headneck_ref[!rownames(headneck_ref) %in% ribo[,1], ]
```

## Step 3: Reference QC
The performance of CHETAH is heavily dependent on the quality of the reference.  
The quality of the reference is affected by: 

1. the quality of the scRNA-seq data
2. the accuracy of the cell type labels
  
To see how well CHETAH can distinguish between the cell types in a reference,  
`CorrelateReference` and more importantly `ClassifyReference` can be run.

### CorrelateReference
`CorrelateReference` is a function that, for every combination of two cell types, finds the 
genes with the highest fold-change between the two and uses these to correlate them to each other. 
If the reference is good, all types will correlate poorly or even better, will anti-correlate.
  
```{r out.width="100%", dpi = 50, fig.height = 6, fig.width = 12}
CorrelateReference(ref_cells = headneck_ref)
```

In this case, most cell types will be distinguishable: many types don't correlate, or anti-correlate. However, some types are quite similar. Regulatory and CD4 T cells, or CD4 and CD8 T cells, might be hard to distinguish in the input data.
  
### ClassifyReference
Another check to see whether CHETAH can distinguish between the cell types in the reference is
`ClassifyReference`. This function uses the reference to classify the reference itself. 
If CHETAH works well with the reference, there should be almost no mix-ups in the classification, i.e.
all cells of type A should be classified to type A.
  
```{r out.width="100%", dpi = 50, fig.height = 6, fig.width = 12, fig.cap = "In this plot, the rows are the original cell type labels, the columns the labels that were assigned during classification. The colors and sizes of the squares indicate which part of the cells of the row name type are classified to the column type. E.g. 4th row, 2th column shows that 5-10% of CD4 T cells are classified as regulatory T cells."}
ClassifyReference(ref_cells = headneck_ref)
```

In this reference, there is never more than 10% mix-up between two cell types. In addition, a low percentage of cells is classified as an intermediate type. Most mix-ups occur between
subtypes of T cells. In this case the user should be aware that these cell type labels have the highest chance to interchange.
  
# Optimizing the classification
CHETAH is optimized to give good results in most analyses, but it can happen that a classification is imperfect.
When CHETAH does not give the desired output (too little cells are classified, visually random classification, etc),  
These are the following steps to take (in this order): 

  * Check if your reference is correctly created (see [above](#ref-prep). This is the most important step!
  * If too little cells are classified, lower the Confidence threshold to 0.05 or 0.01
    + Beware of false positives! Always check if the result makes sense.
    + using `input[!(grepl("^RP", rownames(input))), ]` is an imperfect, but very quick way to do this.
  * Try using a different number of genes for the classification (the `n_genes` parameter).
    + this defaults to 200, but sometimes 100 or (in sparse data) 500 can give better results
  * Find another reference
  * Try one of the other scRNA-seq classification methods available.
  * Open an issue on [github](github.com/jdekanter/CHETAH). We might be able to help you further
    
     

<br><br>
^1^ Van Der Maaten and Hinton (2008). Visualizing high-dimensional data using t-sne. _J Mach Learn Res_. 9: 2579-2605. doi: 10.1007/s10479-011-0841-3.  
^2^ Satija et al. (2015) Spatial reconstruction of single-cell gene expression data. _Nat Biotechnol_. 33(5):495-502. May 2015. doi: 10.1038/nbt.3192. More information at: https://satijalab.org/seurat/   
^3^ Picelli et al. (2013) Smart-seq2 for sensitive full-length transcriptome profiling in single cells. _Nat Methods_. 10(11): 1096-1100. doi: 10.1038/nmeth.2639.  

```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{input_mel}
\alias{input_mel}
\title{A SingleCellExperiment on which CHEATHclassifier is run using the \code{\link{headneck_ref}}
It holds subset of the Melanoma data, from Tirosh et al. (2016), Science.}
\format{
This is a SingleCellExperiment
}
\source{
for the original data: \href{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE72056}{GEO}
}
\usage{
data('input_mel')
}
\description{
A SingleCellExperiment on which CHEATHclassifier is run using the \code{\link{headneck_ref}}
It holds subset of the Melanoma data, from Tirosh et al. (2016), Science.
}
\references{
Tirosh et al. (2016) Science 6282:189-196
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Utils_CHETAH.R
\name{CorrelateReference}
\alias{CorrelateReference}
\title{Correlate all reference profiles to each other
using differentially expressed genes.}
\usage{
CorrelateReference(
  ref_cells = NULL,
  ref_profiles = NULL,
  ref_ct = "celltypes",
  ref_c = NA,
  return = FALSE,
  n_genes = 200,
  fix_ngenes = TRUE,
  print_steps = FALSE,
  only_pos = FALSE
)
}
\arguments{
\item{ref_cells}{the reference, similar to
\code{\link{CHETAHclassifier}}'s ref_cells}

\item{ref_profiles}{similar to
\code{\link{CHETAHclassifier}}'s ref_profiles}

\item{ref_ct}{the colData of \code{ref_cells} where the cell types are stored.}

\item{ref_c}{the assay of \code{ref_cells} to use}

\item{return}{return the matrix that was used to produce the plot}

\item{n_genes}{as in \code{\link{CHETAHclassifier}}}

\item{fix_ngenes}{as in \code{\link{CHETAHclassifier}}}

\item{print_steps}{as in \code{\link{CHETAHclassifier}}}

\item{only_pos}{as in \code{\link{CHETAHclassifier}}}
}
\value{
A square plot. The values show how much two reference profiles
correlate, when using the genes with the highest fold-change.
}
\description{
Correlate all reference profiles to each other
using differentially expressed genes.
}
\examples{
data('headneck_ref')
CorrelateReference(ref_cells = headneck_ref)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{headneck_ref}
\alias{headneck_ref}
\title{A SingleCellExperiment with celltypes in the "celltypes" colData.
A subset of the Head-Neck data from Puram et al. (2017) Cancer Cell.}
\format{
A list of expression matrices. Each object is named as the cell type of the cells in that matrix.
Each matrix has the cell (names) in the colums and the genes in the rows.
}
\source{
for the original data: \href{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE103322}{GEO}
}
\usage{
data('headneck_ref')
}
\description{
A SingleCellExperiment with celltypes in the "celltypes" colData.
A subset of the Head-Neck data from Puram et al. (2017) Cancer Cell.
}
\references{
Puram et al. (2017) Cancer Cell 171:1611-1624
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Utils_CHETAH.R
\name{PlotCHETAH}
\alias{PlotCHETAH}
\title{Plot the CHETAH classification on 2D visulization like t-SNE
+ the corresponding classification tree,
colored with the same colors}
\usage{
PlotCHETAH(
  input,
  redD = NA,
  interm = FALSE,
  return = FALSE,
  tree = TRUE,
  pt.size = 1,
  return_col = FALSE,
  col = NULL
)
}
\arguments{
\item{input}{a SingleCellExperiment on which \code{\link{CHETAHclassifier}} has been run}

\item{redD}{the name of the reducedDim of the input to use for plotting}

\item{interm}{color the intermediate instead of the final types}

\item{return}{return the plot instead of printing it}

\item{tree}{plot the tree, along with the classification}

\item{pt.size}{the point-size of the classication plot}

\item{return_col}{whether the colors that are used for
the classification plot should be returned}

\item{col}{custom colors for the cell types. \emph{the colors
should be named with the corresponding cell types}}
}
\value{
a ggplot object
}
\description{
Plot the CHETAH classification on 2D visulization like t-SNE
+ the corresponding classification tree,
colored with the same colors
}
\examples{
data('input_mel')
#' ## Standard plot (final types colored)
PlotCHETAH(input = input_mel)

## Intermediate types colored
PlotCHETAH(input = input_mel, interm = TRUE)

## Plot only the t-SNE plot
PlotCHETAH(input = input_mel, tree = FALSE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Utils_CHETAH.R
\name{CHETAHclassifier}
\alias{CHETAHclassifier}
\title{Identification of cell types aided by hierarchical clustering}
\usage{
CHETAHclassifier(
  input,
  ref_cells = NULL,
  ref_profiles = NULL,
  ref_ct = "celltypes",
  input_c = NA,
  ref_c = NA,
  thresh = 0.1,
  gs_method = c("fc", "wilcox"),
  cor_method = c("spearman", "kendall", "pearson", "cosine"),
  clust_method = c("average", "single", "complete", "ward.D2", "ward.D", "mcquitty",
    "median", "centroid"),
  clust_dist = bioDist::spearman.dist,
  n_genes = 200,
  pc_thresh = 0.2,
  p_thresh = 0.05,
  fc_thresh = 1.5,
  subsample = FALSE,
  fix_ngenes = TRUE,
  plot.tree = FALSE,
  only_pos = FALSE,
  print_steps = FALSE
)
}
\arguments{
\item{input}{\strong{required}: an input SingleCellExperiment.
(see: \href{https://bioconductor.org/packages/release/bioc/html/SingleCellExperiment.html}{Bioconductor},
and the vignette \code{browseVignettes("CHETAH")})}

\item{ref_cells}{\strong{required}: A reference SingleCellExperiment, with
the cell types in the "celltypes" colData (or otherwise defined in \code{ref_ct}.}

\item{ref_profiles}{\emph{optional} In case of bulk-RNA seq or micro-arrays,
an expression matrix with one (average) reference expression profile
per cell type in the columns. (`ref_cells` must be left empty)}

\item{ref_ct}{the colData of \code{ref_cells} where the cell types are stored.}

\item{input_c}{the name of the assay of the input to use.
\code{NA} (default) will use the first one.}

\item{ref_c}{same as \code{input_c}, but for the reference.}

\item{thresh}{the initial confidence threshold, which can be changed after running
by \code{\link{Classify}})}

\item{gs_method}{method for gene selection. In every node of the tree:
"fc" = quick method: either a fixed number (\code{n_genes})
of genes is selected with the highest fold-change (default),
or genes are selected that have a fold-change higher than \code{fc_thresh}
(the latter is used when \code{fix_ngenes = FALSE}) . \cr
"wilcox": genes are selected based on fold-change (\code{fc_thresh}),
percentage of expression (\code{pc_thresh}) and p-values (\code{p_thresh}),
p-values are found by the wilcox test.}

\item{cor_method}{the correlation measure: one of:
"spearman" (default), "kendall", "pearson", "cosine"}

\item{clust_method}{the method used for clustering the reference profiles.
One of the methods from \code{\link[stats]{hclust}}}

\item{clust_dist}{a distance measure, default: \code{\link[bioDist]{spearman.dist}}}

\item{n_genes}{The number of genes used in every step. Only used if
\code{fix_ngenes = TRUE}}

\item{pc_thresh}{when: \emph{gs_method = "wilcox"}, only genes are selected
for which more than a \code{pc_tresh} fraction of a reference group of cells
express that gene}

\item{p_thresh}{when: \emph{gs_method = "wilcox" }, only genes are selected
that have a p-value < \code{p_thresh}}

\item{fc_thresh}{when: \emph{gs_method = "wilcox" or gs_method = "fc"
AND fix_ngenes = FALSE},
only genes are selected that have a log2 fld-change > \code{fc_thresh}
between two reference groups. \cr
\strong{if this mode is selected, the reference must be in the log2 space}.}

\item{subsample}{to prevent reference types with a lot of cells to influence
the gene selection, subsample types with more that \code{subsample} cells}

\item{fix_ngenes}{when: \emph{gs_method = "fc"} use a fixed number of genes
for all correlations. when: \emph{gs_method = "wilcox"}
use a maximum of genes per step.
When \code{fix_ngenes = FALSE & gs_methode = "fc"} \code{fc_thresh}
is used to define the fold-change cut-off for gene selection.}

\item{plot.tree}{Plot the classification tree.}

\item{only_pos}{\emph{not recommended}: only use genes for a reference type
that are higher expressed in that type, than the others in that node.}

\item{print_steps}{whether the number of genes (postive and negative)
per step per ref_cell_type should be printed}
}
\value{
A SingleCellExperiment with added:
-  input$celltype_CHETAH
a named character vector that can directly be used in any other workflow/method.
-  "hidden" `int_colData` and `int_metadata`, not meant for direct interaction, but
which can all be viewed and interacted with using: `PlotCHETAH` and `CHETAHshiny`
A list containing the following objects is added to input$int_metadata$CHETAH
\itemize{
  \item \strong{classification} a named vector: the classified types
  with the corresponding names of the input cells
  \item \strong{tree} the hclust object of the classification tree
  \item \strong{nodetypes} A list with the cell types under each node
  \item \strong{nodecoor} the coordinates of the nodes of the classification tree
  \item \strong{genes} A list per node, containing a list per
  reference type with the genes used for the profile scores of that type
  \item \strong{parameters} The parameters used
}
A nested DataFrame is added to input$int_colData$CHETAH.
It holds 3 top-levels DataFrames
\itemize{
  \item \strong{prof_scores} A list with the profile scores
  \item \strong{conf_scores} A list with the confidence scores
  \item \strong{correlations} A list with the correlations of the
  input cells to the reference profiles
}
}
\description{
CHETAH classifies an input dataset by comparing it to
a reference dataset in a stepwise, top-to-bottom fashion.
See 'details' for a full explanation.
\emph{NOTE: We recommend to use all the default parameters}
}
\details{
CHETAH will hierarchically cluster reference data
to produce a classification tree (ct).
In each node of the ct, CHETAH will
assign each input cell to on of the two branches, based on gene selections,
correlations and calculation of profile and confidence scores.
The assignement will only performed if the confidence score for
such an assignment is higher than the Confidence Threshold.
If this is not the case, classification for the cell will stop in the current node.
Some input cells will reach the leaf nodes of the ct (the pre-defined cell types),
these classifications are called \strong{final types}
For other cells, assignment will stop in a node. These classifications
are called \strong{intermediate types}.  \cr
}
\examples{
data('input_mel')
data('headneck_ref')
## Melanoma data from Tirosh et al. (2016) Science
input_mel
## Head-Neck data from Puram et al. (2017) Cancer Cell
headneck_ref
input_mel <- CHETAHclassifier(input = input_mel, ref_cells = headneck_ref)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Utils_CHETAH.R
\name{Classify}
\alias{Classify}
\title{(Re)classify after running \code{\link{CHETAHclassifier}} using a confidence threshold \cr
NOTE: In case of bulk reference profiles: only the correlations will be used,
as the data does not allow for profile or confidence scores to be calculated.}
\usage{
Classify(input, thresh = 0.1, return_clas = FALSE)
}
\arguments{
\item{input}{a SingleCellExperiment on which \code{\link{CHETAHclassifier}} has been run}

\item{thresh}{a confidence threshold between -0 and 2. \cr
Selecting 0 will classify all cells, whereas 2 will result i
n (almost) no cells to be classified. \cr
\emph{recommended}: between 0.1 (fairly confident) and 1 (very confident)}

\item{return_clas}{Instead of returning the SingleCellExperiment, only return the classification vector}
}
\value{
a charachter vector of the cell types with the names of the cells
}
\description{
(Re)classify after running \code{\link{CHETAHclassifier}} using a confidence threshold \cr
NOTE: In case of bulk reference profiles: only the correlations will be used,
as the data does not allow for profile or confidence scores to be calculated.
}
\examples{
data('input_mel')
data('headneck_ref')
## Classify all cells
input_mel <- Classify(input_mel, 0)

## Classify only cells with a very high confidence
input_mel <- Classify(input_mel, 1)

## Back to the default
input_mel <- Classify(input_mel)

## Return only the classification vector
celltypes <- Classify(input_mel, 1, return_clas = TRUE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Utils_CHETAH.R
\name{PlotTSNE}
\alias{PlotTSNE}
\title{Plots a variable on a t-SNE}
\usage{
PlotTSNE(
  toplot,
  input,
  redD = NA,
  col = NULL,
  return = FALSE,
  limits = NULL,
  pt.size = 1,
  shiny = NULL,
  y_limits = NULL,
  x_limits = NULL,
  legend_label = ""
)
}
\arguments{
\item{toplot}{the variable that should be plotted. Either a character vector
or a factor, or a (continuous) numeric.
If toplot is not named with the rownames of \code{redD}, it is assumed
that the order of the two is the same.}

\item{input}{a SingleCellExperiment on which \code{\link{CHETAHclassifier}} has been run}

\item{redD}{the name of the reducedDim of the input to use for plotting}

\item{col}{a vector of colors. If \code{toplot} is a numeric,
this will become a continuous scale. \cr
\emph{If \code{toplot} is a charachter vector, the colors should
be named with the unique values (/levels) of toplot}}

\item{return}{instead of printing, return the ggplot object}

\item{limits}{the limits of the continuous variable to plot.
When not provided the minimal and maximal value will be used}

\item{pt.size}{the point-size}

\item{shiny}{Needed for the shiny application: should always be NULL}

\item{y_limits}{the y-axis limits}

\item{x_limits}{the x-axis limits, if NULL}

\item{legend_label}{the label of the legend}
}
\value{
A ggplot object
}
\description{
Plots a variable on a t-SNE
}
\examples{
data('input_mel')
CD8 <- assay(input_mel)['CD8A', ]
PlotTSNE(toplot = CD8, input = input_mel)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Utils_CHETAH.R
\name{CHETAHshiny}
\alias{CHETAHshiny}
\title{Launch a web page to interactively go trough the classification}
\usage{
CHETAHshiny(input, redD = NA, input_c = NA)
}
\arguments{
\item{input}{a SingleCellExperiment on which \code{\link{CHETAHclassifier}} has been run}

\item{redD}{the name of the reducedDim of the input to use for plotting}

\item{input_c}{the name of the assay of the input to use.
\code{NA} (default) will use the first one.}
}
\value{
Opens a web page in your default browser
}
\description{
Launch a web page to interactively go trough the classification
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Utils_CHETAH.R
\name{ClassifyReference}
\alias{ClassifyReference}
\title{Use a reference dataset to classify itself.
A good reference should have almost no mixture
between reference cells.}
\usage{
ClassifyReference(
  ref_cells,
  ref_ct = "celltypes",
  ref_c = "counts",
  return = FALSE,
  ...
)
}
\arguments{
\item{ref_cells}{the reference, similar to
\code{\link{CHETAHclassifier}}'s ref_cells}

\item{ref_ct}{the colData of \code{ref_cells} where the cell types are stored.}

\item{ref_c}{same as \code{input_c}, but for the reference.}

\item{return}{return the matrix that was used to produce the plot}

\item{...}{Other variables to pass to
\code{\link{CHETAHclassifier}}}
}
\value{
A square plot. The rows are the original cell types,
the columns the classifion labels.
The colors and sizes of the squares indicate which
part of the cells of the rowname type are
classified to the type of the column name.
On the left of the plot, the percentage of cells
that is classified to an intermediate type
is plotted.
A good reference would classify nearly 100% of cells of type A to type A.
}
\description{
Use a reference dataset to classify itself.
A good reference should have almost no mixture
between reference cells.
}
\examples{
data('headneck_ref')
ClassifyReference(ref_cells = headneck_ref)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Utils_CHETAH.R
\name{PlotTree}
\alias{PlotTree}
\title{Plots the chetah classification tree with nodes numbered}
\usage{
PlotTree(
  input,
  col = NULL,
  col_nodes = NULL,
  return = FALSE,
  no_bgc = FALSE,
  plot_limits = c(-0.4, 0.1),
  labelsize = 6
)
}
\arguments{
\item{input}{a SingleCellExperiment on which \code{\link{CHETAHclassifier}} has been run}

\item{col}{a vector of colors, with the names of the reference cell types}

\item{col_nodes}{a vector of colors, ordered for node 1 till the last node}

\item{return}{instead of printing, return the ggplot object}

\item{no_bgc}{remove the background color from the node numbers}

\item{plot_limits}{define the % of the plot_heigth that should be used as a margin below and above the plot
Decreasing the former further is usefull when the labels are cut of the plot (default = c(-0,25, 01)).}

\item{labelsize}{the size of the intermediate and leaf node labels (default = 6)}
}
\value{
A ggplot object of the classification tree
}
\description{
Plots the chetah classification tree with nodes numbered
}
\examples{
data('input_mel')
PlotTree(input = input_mel)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Utils_CHETAH.R
\name{RenameBelowNode}
\alias{RenameBelowNode}
\title{In the CHETAH classification, replace the name of a Node
and all the names of the final and intermediate types under that Node.}
\usage{
RenameBelowNode(
  input,
  whichnode,
  replacement,
  nodes_exclude = NULL,
  types_exclude = NULL,
  node_only = FALSE,
  return_clas = FALSE
)
}
\arguments{
\item{input}{a SingleCellExperiment on which \code{\link{CHETAHclassifier}} has been run}

\item{whichnode}{the number of the Node}

\item{replacement}{a character vector that replaces the names under the selected Node}

\item{nodes_exclude}{\emph{optional} the names of the types that should  \strong{NOT} be replaced}

\item{types_exclude}{\emph{optional} numbers of the Nodes under the selected Node, that should \strong{NOT} be replaced}

\item{node_only}{only rename the Node itself, without affecting the types under that Node}

\item{return_clas}{Instead of returning the SingleCellExperiment, only return the classification vector}
}
\value{
The SingleCellExperiment with the new classification or if `return_clas = TRUE` the classification vector.
}
\description{
In the CHETAH classification, replace the name of a Node
and all the names of the final and intermediate types under that Node.
}
\examples{
## In the example data replace all T-cell subtypes by "T cell"
data('input_mel')
#' input_mel <- RenameBelowNode(input = input_mel, whichnode = 7, replacement = "T cell")
}
